<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_contentaction.asp
' Summary  - Handle content actions
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("pages")

' variable declaration
Dim int_contentid, str_contenttitle, str_contentbody, bln_hide, int_parentid, int_ordinal, int_pageid, str_setcontentname
Dim str_action, str_redirect, str_msg, bln_refer
Dim conn, rs, rs_max, rs_parent
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_pages.asp"-->
<!--#include file="includes/acmsi_content.asp"-->
<%

' get form values
str_action = GetValue("action","")
int_pageid = GetValue("pageid",0) 
int_contentid = GetValue("id",0) 
str_contenttitle = GetValue("title","") 
str_contentbody = GetValue("content","")
bln_hide = GetValue("hide",False)
int_parentid = GetValue("parent",0)
int_ordinal = GetValue("ordinal",0)
bln_refer = GetValue("refer",false)

OpenDatabase conn
Select Case lcase(str_action)

	' Add new content to the specified page
	Case "add"
	
		' Get the maximum number value of ordinal for the selected parent to determine what ordinal to set the new content
		ExecuteRecordset q_SelectMaxRecordPlus("ordinal","acmstbl_content","parentid",int_parentid,"number","pageid = " & int_pageid), conn, rs_max
		If Not rs_max.EOF Then int_ordinal = rs_max(0) + 1
		CloseRecordset rs_max
		' If no records returned, assume first record for the selected parent
		If Not IsNumeric(int_ordinal) Then int_ordinal = 1
		If int_ordinal=0 Then int_ordinal = 1

		' Check if parent is set content
		If int_parentid > 0 Then
			ExecuteRecordset q_SelectTable("setcontentname","acmstbl_content","","","id",int_parentid,"number"), conn, rs_parent
			If Not rs_parent.EOF Then str_setcontentname = rs_parent("setcontentname")
			CloseRecordset rs_parent
		End If
				
		' Add information to database
		int_contentid = q_InsertContent(conn,str_contenttitle,str_contentbody,int_ordinal,bln_hide,int_parentid,int_pageid,str_setcontentname)
		
		str_redirect = "acms_contentedit.asp?id=" & int_contentid & "&pageid=" & int_pageid
		str_msg = GetLanguage("lang_contentadded")
		
		' Set the page to modified status
		q_SetModifiedPage conn,int_pageid,True
	
	' Update existing content
	Case "update"
			
		' Update information in database
		OpenUpdateRecordset q_SelectTable("","acmstbl_content","","","id",int_contentid,"number"), conn, rs
		rs("title") = str_contenttitle
		rs("contentbody") = str_contentbody
		rs("pageid") = int_pageid
		rs("hide") = bln_hide
		
		' If parent changed, then change order accordingly
		If CLng(rs("parentid")) <> CLng(int_parentid) Then
			' Update content order after selected content
			OpenUpdateRecordset q_SelectTable("ordinal","acmstbl_content","","(ordinal > " & rs("ordinal") & ") AND (pageid=" & int_pageid & ")","parentid",rs("parentid"),"number"), conn, rs_max
			Do Until rs_max.EOF
				rs_max("ordinal") = rs_max("ordinal") - 1
				rs_max.Update
				rs_max.MoveNext
			Loop
			CloseRecordset rs_max
			
			' Set selected content to the bottom of the newly assigned parent
			ExecuteRecordset q_SelectMaxRecordPlus("ordinal","acmstbl_content","parentid",int_parentid,"number","pageid=" & int_pageid), conn, rs_max
			If Not rs_max.EOF Then int_ordinal = rs_max(0) + 1
			CloseRecordset rs_max
			If Not NotEmpty(int_ordinal) Then int_ordinal = 1
			rs("ordinal") = int_ordinal
			
			' Check if parent is set content
			If int_parentid > 0 Then
				ExecuteRecordset q_SelectTable("setcontentname","acmstbl_content","","","id",int_parentid,"number"), conn, rs_parent
				If Not rs_parent.EOF Then str_setcontentname = rs_parent("setcontentname")
				CloseRecordset rs_parent
				rs("setcontentname") = str_setcontentname
			Else
				rs("setcontentname") = ""
			End If
			
			' Set children's setcontentname
			SetChildrenContentName int_contentid, str_setcontentname
		End If
		rs("parentid") = int_parentid
		
		rs.Update
		str_redirect = "acms_contentedit.asp?id=" & int_contentid & "&pageid=" & int_pageid
		str_msg = GetLanguage("lang_contentupdated")
		CloseRecordset rs

		' Set the page to modified status
		q_SetModifiedPage conn,int_pageid, True
	
	' Delete content from database
	Case "delete"
	
		' Update content order after selected content (move content below up)
		OpenUpdateRecordset q_SelectTable("ordinal,title","acmstbl_content","ordinal","(ordinal > " & int_ordinal & ") AND (pageid=" & int_pageid & ")","parentid",int_parentid,"number"), conn, rs
		Do Until rs.EOF
			rs("ordinal") = rs("ordinal") - 1
			rs.Update		
			rs.MoveNext
		Loop
		CloseRecordset rs

		' Delete record from database
		ExecuteRecordset q_DeleteTable("acmstbl_content","id",int_contentid,"number"), conn, rs
		str_redirect = "acms_pageedit.asp?id=" & int_pageid
		str_msg = GetLanguage("lang_contentdeleted")
		
		' Set the page to modified status
		q_SetModifiedPage conn,int_pageid, True
	
	' Move the content order up
	Case "moveup"
	
		' Check if it's at the top already
		If int_ordinal > 1 Then q_UpdateContentOrdinal conn,int_contentid,int_pageid,int_ordinal,int_parentid,"up"
		str_redirect = "acms_pageedit.asp?id=" & int_pageid
		
		' Set the page to modified status
		q_SetModifiedPage conn,int_pageid, True
	
	' Move the content order down
	Case "movedn"

		' Check if content is already at bottom
		ExecuteRecordset q_SelectMaxRecordPlus("ordinal","acmstbl_content","parentid",int_parentid,"number","pageid=" & int_pageid), conn, rs_max
		If Not rs_max.EOF Then
			If CLng(int_ordinal) < CLng(rs_max(0)) Then q_UpdateContentOrdinal conn,int_contentid,int_pageid,int_ordinal,int_parentid,"down"
		End If
		CloseRecordset rs_max
		str_redirect = "acms_pageedit.asp?id=" & int_pageid
		
		' Set the page to modified status
		q_SetModifiedPage conn,int_pageid, True
	
	' Move the parent of the content up a level
	Case "movetoparent"
	
		' Check if content is already at Top Level
		If int_parentid > 0 Then
			
			' Update content order after selected content
			OpenUpdateRecordset q_SelectTable("ordinal","acmstbl_content","ordinal","(ordinal > " & int_ordinal & ") AND (pageid = " & int_pageid & ")","parentid",int_parentid,"number"), conn, rs
			Do Until rs.EOF
				rs("ordinal") = rs("ordinal") - 1
				rs.Update		
				rs.MoveNext
			Loop
			CloseRecordset rs			
			
			' Get new parent ID of current parent
			ExecuteRecordset q_SelectTable("parentid","acmstbl_content","","(pageid = " & int_pageid & ")","id",int_parentid,"number"), conn, rs
			If Not rs.EOF Then int_parentid = rs(0)
			CloseRecordset rs
			
			' Get new ordinal from new parent
			ExecuteRecordset q_SelectMaxRecordPlus("ordinal","acmstbl_content","parentid",int_parentid,"number","pageid=" & int_pageid), conn, rs_max
			If Not rs_max.EOF Then int_ordinal = rs_max(0)
			CloseRecordset rs_max
			
			' Update record
			OpenUpdateRecordset q_SelectTable("ordinal,parentid","acmstbl_content","","","id",int_contentid,"number"), conn, rs
			If Not rs.EOF Then	
				rs("ordinal") = int_ordinal + 1
				rs("parentid") = int_parentid
				rs.Update
			End If
			CloseRecordset rs
			
		End If
		str_redirect = "acms_pageedit.asp?id=" & int_pageid
		
		' Set the page to modified status
		q_SetModifiedPage conn,int_pageid, True
		
	Case "hide"
		
		' Update hide value to True/Yes/1
		q_UpdateBoolean conn,"acmstbl_content","id",int_contentid,"hide",True
		str_redirect = "acms_pageedit.asp?id=" & int_pageid
		
		' Set the page to modified status
		q_SetModifiedPage conn,int_pageid, True
		
	Case "unhide"
		
		' Update hide value to False/No/0
		q_UpdateBoolean conn,"acmstbl_content","id",int_contentid,"hide",False
		str_redirect = "acms_pageedit.asp?id=" & int_pageid
		
		' Set the page to modified status
		q_SetModifiedPage conn,int_pageid, True
	
	Case Else

End Select
CloseDatabase conn

If NotEmpty(str_msg) Then WriteSession "adminmessage", str_msg
If bln_refer Then Response.Redirect GetReferPage
If NotEmpty(str_redirect) Then Response.Redirect str_redirect
%>