<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_contentedit.asp
' Summary  - Edit content details; displays content and snippet list
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("pages")

' variable declaration
Dim int_contentid, str_contenttitle, str_contentbody, bln_hide, int_parentid, str_setcontentname
Dim str_hidechecked, str_css
Dim int_pageid, str_pagetitle
Dim str_action, str_submittext, str_breadcrumb
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_pages.asp"-->
<!--#include file="includes/acmsi_content.asp"-->
<!--#include file="includes/acmsi_tags.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' content specific functions and subroutines
Sub DoContentList(parentid, level, selectedid, pageid, contentid)
	
	Dim int_contentid, str_contenttitle, str_selectedparent
	Dim str_prefix
	Dim rs, i
	
	ExecuteRecordset q_SelectTable("id,title","acmstbl_content","ordinal,id","pageid = " & pageid,"parentid",parentid,"number"), conn, rs

	If Not rs.EOF Then
		Do Until rs.EOF
			int_contentid = rs("id")
			str_contenttitle = rs("title")
			
			str_prefix = ""
			For i = 1 To level
				str_prefix = "--" & str_prefix
			Next
			str_selectedparent = ""
			If CInt(int_contentid) = CInt(selectedid) Then str_selectedparent = " selected=""selected"""
			If (CLng(parentid) <> CLng(contentid)) And (CLng(int_contentid) <> CLng(contentid)) Then 
				Response.Write "	<option value=""" & int_contentid & """" & str_selectedparent & ">" & str_prefix & " " & str_contenttitle & "</option>" & vbCrLf
				DoContentList int_contentid, level + 1, selectedid, pageid, contentid
			End If	
			rs.MoveNext
		Loop
	End If
	
	CloseRecordset rs
	
End Sub

Sub DoContentTree(parentid, level, contentid)
	
	Dim int_contentid, str_contenttitle, int_parentid, int_ordinal, bln_hide, str_setcontentname
	Dim str_setcontentclass
	Dim rs, rs_child
	
	ExecuteRecordset q_SelectTable("*","acmstbl_content","setcontentname,ordinal,id","pageid = " & int_pageid,"parentid",parentid,"number"), conn, rs

	If Not rs.EOF Then
		Do Until rs.EOF
			int_contentid = rs("id")
			str_contenttitle = rs("title")
			int_parentid = rs("parentid")
			int_ordinal = rs("ordinal")
			bln_hide = CBool(rs("hide"))
			str_setcontentname = rs("setcontentname")

			str_setcontentclass = ""
			If NotEmpty(str_setcontentname) Then str_setcontentclass = " setcontent"
			
			Response.Write "<tr>" & vbCrLf
			DoDataOutput "acms_contentedit.asp?parentid=" & int_contentid,"<img src=""images/admin/add.gif"" alt=""" & GetLanguage("lang_add") & """ title=""" & GetLanguage("lang_add") & """ />","","icon","td",""
			If level = 0 and NotEmpty(str_setcontentname) Then
				DoDataOutput "","&nbsp;","","icon","td",""
				DoDataOutput "","&nbsp;","","icon","td",""
			Else
				DoDataOutput "acms_contentaction.asp?refer=true&amp;id=" & int_contentid & "&amp;parent=" & int_parentid & "&amp;ordinal=" & int_ordinal & "&amp;pageid=" & int_pageid & "&amp;action=moveup","<img src=""images/admin/up.gif"" alt=""" & GetLanguage("lang_moveup") & """ title=""" & GetLanguage("lang_moveup") & """ />","","icon","td",""
				DoDataOutput "acms_contentaction.asp?refer=true&amp;id=" & int_contentid & "&amp;parent=" & int_parentid & "&amp;ordinal=" & int_ordinal & "&amp;pageid=" & int_pageid & "&amp;action=movedn","<img src=""images/admin/down.gif"" alt=""" & GetLanguage("lang_movedown") & """ title=""" & GetLanguage("lang_movedown") & """ />","","icon","td",""
			End If
			If (parentid > 0) and Not(level>0 AND NotEmpty(str_setcontentname)) Then
				DoDataOutput "acms_contentaction.asp?refer=true&amp;id=" & int_contentid & "&amp;parent=" & int_parentid & "&amp;ordinal=" & int_ordinal & "&amp;pageid=" & int_pageid & "&amp;action=movetoparent","<img src=""images/admin/toparent.gif"" alt=""" & GetLanguage("lang_movetoparent") & """ title=""" & GetLanguage("lang_movetoparent") & """ />","","icon","td",""
			Else
				DoDataOutput "","&nbsp;","","icon","td",""
			End If
			
			If CLng(contentid)<>CLng(int_contentid) Then
				DoDataOutput "acms_contentedit.asp?id=" & int_contentid,Server.HTMLEncode(str_contenttitle),"padding-left:" & level*20 & "px","maincol" & str_setcontentclass,"td",""
				If bln_hide Then
					DoDataOutput "acms_contentaction.asp?refer=true&amp;id=" & int_contentid & "&amp;pageid=" & int_pageid & "&amp;action=unhide","<img src=""images/admin/empty.gif"" alt=""" & GetLanguage("lang_unhide") & """ title=""" & GetLanguage("lang_unhide") & """ />","","icon","td",""
				Else
					DoDataOutput "acms_contentaction.asp?refer=true&amp;id=" & int_contentid & "&amp;pageid=" & int_pageid & "&amp;action=hide","<img src=""images/admin/full.gif"" alt=""" & GetLanguage("lang_hide") & """ title=""" & GetLanguage("lang_hide") & """ />","","icon","td",""
				End If
				
				ExecuteRecordset q_SelectTable("id","acmstbl_content","","","parentid",int_contentid,"number"), conn, rs_child
				If rs_child.EOF and Not(level = 0 and NotEmpty(str_setcontentname)) Then
					DoDataOutput "javascript:confirmdelete('acms_contentaction.asp?refer=true&amp;id=" & int_contentid & "&amp;pageid=" & int_pageid & "&amp;ordinal=" & int_ordinal & "&amp;parent=" & int_parentid & "&amp;action=delete','" & str_contenttitle & "')","<img src=""images/admin/cross.gif"" alt=""" & GetLanguage("lang_delete") & """ title=""" & GetLanguage("lang_delete") & """ />","","icon","td",""
				Else
					DoDataOutput "","&nbsp;","","icon","td",""
				End If
			Else
				DoDataOutput "",Server.HTMLEncode(str_contenttitle),"padding-left:" & level*20 & "px; color:#aaa;","maincol al addindent" & str_setcontentclass,"td",""
				If bln_hide Then
					DoDataOutput "acms_contentaction.asp?refer=true&amp;id=" & int_contentid & "&amp;pageid=" & int_pageid & "&amp;action=unhide","<img src=""images/admin/empty.gif"" alt=""" & GetLanguage("lang_unhide") & """ title=""" & GetLanguage("lang_unhide") & """ />","","icon","td",""
				Else
					DoDataOutput "acms_contentaction.asp?refer=true&amp;id=" & int_contentid & "&amp;pageid=" & int_pageid & "&amp;action=hide","<img src=""images/admin/full.gif"" alt=""" & GetLanguage("lang_hide") & """ title=""" & GetLanguage("lang_hide") & """ />","","icon","td",""
				End If
				DoDataOutput "","&nbsp;","","icon","td",""
			End If
			
			Response.Write "</tr>" & vbCrLf
			DoContentTree int_contentid, level + 1, contentid
			rs.MoveNext
		Loop
	End If
	
	CloseRecordset rs
	
End Sub

Sub DoSnippetList(contentid)
	
	Dim rs, rs_content
	Dim int_snippetid, str_snippetkeyword, str_snippettitle, int_firstcontent
	Dim str_contentlinks
	Dim bln_found
	
	bln_found = false
	ExecuteRecordset q_SelectTable("*","acmstbl_snippets","title","","","",""), conn, rs

	If Not rs.EOF Then
		Do Until rs.EOF
			int_snippetid = rs("id")
			str_snippettitle = rs("title")
			str_snippetkeyword = rs("keyword")
			int_firstcontent = 0
			
			ExecuteRecordset q_SelectTable("id,title,pageid","acmstbl_content","title","contentbody LIKE '%{acms:snp(" & str_snippetkeyword & ")%'","id",contentid,"number"), conn, rs_content
		
			Do Until rs_content.EOF
				bln_found = True
				Response.Write "<tr>" & vbCrLf
				Response.Write "	<td class=""smlindent al""><a href=""acms_snippetedit.asp?id=" & int_snippetid & "&amp;contentid=" & contentid & """>" & Server.HTMLEncode(str_snippettitle) & "</a></td>"
				Response.Write "</tr>"
				rs_content.MoveNext
			Loop
			CloseRecordset rs_content
			rs.MoveNext
		Loop
	End If
	
	If Not bln_found Then
		Response.Write "<tr>" & vbCrLf
		Response.Write "	<td class=""smlindent al"" colspan=""2"">" & GetLanguage("lang_nodirectsnippets") & "</td>"
		Response.Write "</tr>" & vbCrLf
	End If
	CloseRecordset rs
	
End Sub

Sub GetContentInformation ()
	
	Dim obj_matches, obj_match
	Dim rs, rs_page
	int_contentid = GetValue("id",-1)
	int_pageid = GetValue("pageid",0)
	int_parentid = GetValue("parentid",0)
	
	If int_contentid < 0 Then
		str_action = "add"
		str_submittext = GetLanguage("lang_add")
		str_breadcrumb = GetLanguage("lang_addcontent")
		If int_parentid > 0 Then
			OpenRecordset q_SelectInnerJoin("acmstbl_pages.id AS pageid,acmstbl_pages.title AS pagetitle","acmstbl_content","","","id",int_parentid,"number","acmstbl_pages","pageid","id"), conn, rs
			int_pageid = rs("pageid")
			str_pagetitle = rs("pagetitle")
			CloseRecordset rs
		ElseIf int_pageid > 0 Then
			OpenRecordset q_SelectTable("id,title","acmstbl_pages","","","id",int_pageid,"number"), conn, rs
			int_pageid = rs("id")
			str_pagetitle = rs("title")
			CloseRecordset rs
		End If
	Else
		str_action = "update"
		str_submittext = GetLanguage("lang_update")
		OpenRecordset q_SelectInnerJoin("acmstbl_content.*,acmstbl_pages.title AS pagetitle","acmstbl_content","","","id",int_contentid,"number","acmstbl_pages","pageid","id"), conn, rs
		If Not rs.EOF Then
			int_pageid = rs("pageid")
			str_contenttitle = rs("title")
			str_breadcrumb = str_contenttitle
			str_contentbody = rs("contentbody")
			str_pagetitle = Server.HTMLEncode(rs("pagetitle"))
			str_setcontentname = rs("setcontentname")
			bln_hide = CBool(rs("hide"))
			If bln_hide Then str_hidechecked = " checked=""checked"""
			int_parentid = rs("parentid")
		Else
			CloseRecordset rs
			SetError GetLanguage("lang_contentdoesnotexist"),"acms_pagelist.asp"
		End If
		CloseRecordset rs
	End If
		
End Sub

' Content
Sub DoMainAdminContent ()
	OpenDatabase conn
	GetContentInformation
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <a href="acms_pagelist.asp"><%=GetLanguage("lang_menu_pages")%>...</a>&nbsp; <a href="acms_pageedit.asp?id=<%=int_pageid%>"><%=str_pagetitle%>...</a>&nbsp; <%=str_breadcrumb%></div>
	<form method="post" action="acms_contentaction.asp" onsubmit="return validate_content(this);" name="frm_content">
		<% DoEditorSave "frm_content" %>
		<input type="hidden" name="id" value="<%=int_contentid%>" />
		<input type="hidden" name="pageid" value="<%=int_pageid%>" />
		<input type="hidden" name="action" value="<%=str_action%>" />
		<table class="form">
			<tr>
				<th><%=GetLanguage("lang_title")%></th>
				<td><input type="text" name="title" value="<%=str_contenttitle%>" class="textbox" onblur="onblurvalidate(this);" /> *</td>
			</tr>
			<tr><th colspan="2"><%=GetLanguage("lang_content")%></th></tr>
			<tr><td colspan="2"><% DoEditor "frm_content", "content", str_contentbody %></td></tr>
			<tr>
				<th><%=GetLanguage("lang_parent")%></th>
				<td>
					<select name="parent" size="1">
						<option value="0"><%=GetLanguage("lang_toplevel")%></option>
						<% If Not (NotEmpty(str_setcontentname) And (int_parentid = 0)) Then DoContentList 0, 0, int_parentid, int_pageid, int_contentid%>
					</select>
				</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_hide")%></th>
				<td><input type="checkbox" name="hide"<%=str_hidechecked%> value="True" /></td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td>
					<input type="submit" name="submit" value="<%=str_submittext%>" class="submitbtn" onclick="save()" />
				</td>
			</tr>
		</table>
	</form>
	<h2><%=GetLanguage("lang_menu_snippets")%></h2>
	<table class="tree">
		<%
		DoSnippetList int_contentid
		%>
	</table>
	<h2><%=GetLanguage("lang_content")%></h2>
	<table class="tree">
		<tr><td colspan="7" class="add"><a href="acms_contentedit.asp?pageid=<%=int_pageid%>"><%=GetLanguage("lang_add") & " " & GetLanguage("lang_content")%></a></td></tr>
		<% DoContentTree 0,0,int_contentid %>
	</table>
	<table class="form auto">
		<tr>
			<td>
				<form method="post" action="acms_pageaction.asp" target="_blank">
					<input type="hidden" name="id" value="<%=int_pageid%>" />
					<input type="hidden" name="action" value="preview" />
					<input type="submit" name="submit" value="<%=GetLanguage("lang_previewpage")%>" class="submitbtn" />
				</form>
			</td>
			<td>
				<form method="post" action="acms_pageaction.asp">
					<input type="hidden" name="id" value="<%=int_pageid%>" />
					<input type="hidden" name="action" value="generate" />
					<input type="submit" name="submit" value="<%=GetLanguage("lang_generatepage")%>" class="submitbtn" />
				</form>
			</td>
			<td>
				<form method="post" action="acms_pageaction.asp" target="_blank">
					<input type="hidden" name="id" value="<%=int_pageid%>" />
					<input type="hidden" name="action" value="view" />
					<input type="submit" name="submit" value="<%=GetLanguage("lang_viewpage")%>" class="submitbtn" />
				</form>
			</td>
		</tr>
	</table>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<table class="tbl_instructions">
			<tr>
				<th><%=GetLanguage("lang_title")%></th>
				<td>The name of the content block, and is mostly used just as an identifier in the admin. <strong>Required</strong></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_content")%></th>
				<td>The HTML code of the content.</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_parent")%></th>
				<td>Create the content as a subset of an existing content block, or set to "Top Level" to set it as a main content block.</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_hide")%></th>
				<td>Hide the content from being generated.  Instead of deleting content, this function can be
				used to allow content to be shown at a later stage without recreating the content.</td>
			</tr>
		</table>
	</div>
<%
End Sub
%>