<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_templateaction.asp
' Summary  - Handles templates actions
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("filemanager")

' variable declaration
Dim str_filename, str_directory, str_subdirectory, str_newfilename, str_content, str_fileextension
Dim str_action, str_redirect, str_msg
Dim fs, file_item, upload, folder, arr_filetypes, arr_filename
Dim conn, rs
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_snippets.asp"-->
<!--#include file="includes/acmsi_pages.asp"-->
<!--#include file="includes/acmsi_templates.asp"-->
<!--#include file="includes/clsUpload.asp"-->
<%
' get form values
Set upload = New clsUpload
str_action = upload("action").Value
str_directory = upload("directory").Value
str_filename= upload("filename").Value
str_subdirectory = upload("subdirectory").Value
str_content = upload("content").Value

Select Case lcase(str_action)

	Case "add"
	
		If str_filename = "" Then
			SetError GetLanguage("lang_filenamerequired"), GetReferPage
		ElseIf str_content = "" Then
			SetError GetLanguage("lang_contentrequired"), GetReferPage
		End If
		
		OpenFSO fs
		
		SplitValue lcase(c_FILETYPESEDITABLE & "," & c_TEMPLATEFILETYPE), arr_filetypes, ","
		SplitValue str_filename, arr_filename, "."
		If Ubound(arr_filename) > 0 Then
			str_fileextension = arr_filename(Ubound(arr_filename))
		Else
			SetError GetLanguage("lang_invalidfiletype"), GetReferPage
		End If
		
		If ValueInArray(str_fileextension,arr_filetypes) OR GetCookie("super") Then
			WriteFile str_directory & "\" & str_filename, str_content
			str_msg = GetLanguage("lang_fileadded")
		Else
			SetError GetLanguage("lang_invalidfiletype"), GetReferPage
		End If
		str_redirect = "acms_fileedit.asp?directory=" & Server.URLEncode(str_directory) & "&filename=" & Server.URLEncode(str_filename)
		str_msg = GetLanguage("lang_contentadded")
		CloseFSO fs
	
	Case "edit"
	
		If str_filename = "" Then
			SetError GetLanguage("lang_filenamerequired"), GetReferPage
		ElseIf str_content = "" Then
			SetError GetLanguage("lang_contentrequired"), GetReferPage
		End If
		
		OpenFSO fs
		WriteFile str_directory & "\" & str_filename, str_content
		str_redirect = GetReferPage
		str_msg = GetLanguage("lang_contentupdated")
		CloseFSO fs
	
	Case "create"

		OpenFSO fs
		str_subdirectory = RemoveUnsafeDirChars(str_subdirectory)
		CreateDirectory str_directory & "\" & str_subdirectory, fs, False
		str_redirect = GetReferPage
		str_msg = GetLanguage("lang_directorycreated")
		CloseFSO fs
		
	Case "upload"
		
		str_fileextension = lcase(upload("File1").FileExt)
		SplitValue lcase(c_FILETYPESEDITABLE & "," & c_FILETYPESVIEWABLE & "," & c_TEMPLATEFILETYPE), arr_filetypes, ","
		If ValueInArray(str_fileextension,arr_filetypes) OR GetCookie("super") Then
			folder = str_directory & "\"
			upload("File1").SaveAs folder & upload("File1").FileName
			str_msg = GetLanguage("lang_fileuploaded")
		Else
			SetError GetLanguage("lang_invalidfiletype"), GetReferPage
		End If
		str_redirect = GetReferPage
		

	Case Else
	
		str_redirect = "acms_filelist.asp"

End Select

Set upload = Nothing

If NotEmpty(str_msg) Then WriteSession "adminmessage", str_msg
If NotEmpty(str_redirect) Then Response.Redirect str_redirect
%>