<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_fileedit.asp
' Summary  - Edit Files on the web server
' Version  - 0.7B
' Updated  - 28 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("filemanager")

' variable declaration
Dim str_filename, str_directory, str_content
Dim arr_editfiletypes
Dim str_displaydirectory, str_rootdirectory, str_displayfile
Dim str_action, str_submittext, str_breadcrumb
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' content specific functions and subroutines
Sub GetFileInformation ()
	
	Dim fs
	
	str_filename = GetValue("filename","")
	str_directory = GetValue("directory","")
	
	If NotEmpty(str_filename) Then
		
		SplitValue c_FILETYPESEDITABLE & "," & c_TEMPLATEFILETYPE, arr_editfiletypes, ","
		
		OpenFSO fs
		If Instr(lcase(str_directory),lcase(Server.MapPath("."))) = 0 Then
			CloseFSO fs
			SetError GetLanguage("lang_invaliddirectory"),"acms_filelist.asp"
		ElseIf Not ValueInArray(fs.GetExtensionName(str_directory & "\" & str_filename),arr_editfiletypes) Then	
			CloseFSO fs
			SetError GetLanguage("lang_invalidfile"),"acms_filelist.asp"
		End If
		CloseFSO fs
	
		str_action = "edit"
		str_submittext = GetLanguage("lang_edit")
		str_content = ReadFile(str_directory & "\" & str_filename)
		str_breadcrumb = Server.HTMLEncode(str_filename)
		str_filename = Server.HTMLEncode(str_filename)
		str_displayfile = str_filename & "<input type=""hidden"" name=""filename"" value=""" & str_filename & """ />"
	Else
		str_action = "add"
		str_submittext = GetLanguage("lang_add")
		str_breadcrumb = GetLanguage("lang_addfile")
		str_displayfile = "<input type=""text"" name=""filename"" class=""textbox"" onblur=""onblurvalidate(this);"" /> *"
	End If
	
	If lcase(str_directory) = lcase(Server.MapPath(".")) Then
		str_displaydirectory = "root"
	Else
		str_rootdirectory = "<a href=""acms_filelist.asp?directory=" & Server.URLEncode(Server.MapPath(".")) & """>root...</a>&nbsp;"
		str_displaydirectory = Replace(lcase(str_directory),lcase(Server.MapPath(".") & "\"),"")
	End If
	
End Sub

' Content
Sub DoMainAdminContent ()
	GetFileInformation
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <%=str_rootdirectory%>
		<a href="acms_filelist.asp?directory=<%=Server.URLEncode(str_directory)%>"><%=str_displaydirectory%>...</a>&nbsp;
		<%=str_breadcrumb%>
	</div>
	<form method="post" action="acms_fileaction.asp" name="frm_file" onsubmit="return validate_file(this)" enctype="multipart/form-data">
		<input type="hidden" name="directory" value="<%=str_directory%>" />
		<input type="hidden" name="action" value="<%=str_action%>" />
		<table class="form">
			<tr>
				<th><%=GetLanguage("lang_filename")%></th>
				<td><%=str_displayfile%></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_content")%></th>
				<td><textarea name="content" class="template" onblur="onblurvalidate(this)"><%=str_content%></textarea> *</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td>
					<input type="submit" name="submit" value="<%=str_submittext%>" class="submitbtn" />
				</td>
			</tr>
		</table>
	</form>
<%
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<table class="tbl_instructions">
			<tr>
				<th><%=GetLanguage("lang_filename")%></th>
				<td>The filename of the file. <strong>Required</strong></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_content")%></th>
				<td>The content of the file. <strong>Required</strong></td>
			</tr>
		</table>
	</div>
<%
End Sub
%>