<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_languageaction.asp
' Summary  - Handle language actions
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser(c_SUPERONLYACCESS)

' variable declaration
Dim int_languageid, str_languagetitle, str_filename, str_keyword
Dim bln_disabled
Dim str_action, str_redirect, str_msg
Dim conn, rs
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<%

' get form values
str_action = GetValue("action","")
int_languageid = GetValue("id",0) 
str_languagetitle = GetValue("title","") 
str_filename = GetValue("filename","")
str_keyword = GetValue("keyword","")
bln_disabled = GetValue("disabled",False)

OpenDatabase conn
Select Case lcase(str_action)
			
	Case "add"
	
		' Check required field
		If str_languagetitle = "" Then SetError GetLanguage("lang_titlerequired"), "acms_languageedit.asp"
		
		' Check if existing keyword exists
		If NotEmpty(str_keyword) Then
			ExecuteRecordset q_SelectTable("keyword","acmstbl_languages","","","keyword",str_keyword,"string"), conn, rs
			If Not rs.EOF Then 
				CloseRecordset rs
				SetError GetLanguage("lang_keywordexists"), "acms_languageedit.asp"
			End If
			CloseRecordset rs
		Else
			SetError GetLanguage("lang_keywordrequired"), "acms_languageedit.asp"
		End If
		
		' Add data
		int_languageid = q_InsertLanguage(conn,str_languagetitle,str_filename,str_keyword,bln_disabled)
		
		str_redirect = "acms_languageedit.asp?id=" & int_languageid
		str_msg = GetLanguage("lang_languageadded")
			
	Case "update"
		
		' Check required field
		If str_languagetitle = "" Then SetError GetLanguage("lang_titlerequired"), "acms_languageedit.asp"
		
		' Check if existing keyword exists
		If NotEmpty(str_keyword) Then
			ExecuteRecordset q_SelectTable("keyword","acmstbl_languages","","id<>" & int_languageid,"keyword",str_keyword,"string"), conn, rs
			If Not rs.EOF Then 
				CloseRecordset rs
				SetError GetLanguage("lang_keywordexists"), "acms_languageedit.asp?id=" & int_languageid
			End If
			CloseRecordset rs
		Else
			SetError GetLanguage("lang_keywordrequired"), "acms_languageedit.asp?id=" & int_languageid
		End If
		
		' Check required field
		If str_languagetitle = "" Then SetError GetLanguage("lang_titlerequired"), "acms_languageedit.asp?id=" & int_languageid
		
		' Update data
		q_UpdateLanguage conn,int_languageid,str_languagetitle,str_filename,str_keyword,bln_disabled
				
		str_redirect = "acms_languageedit.asp?id=" & int_languageid
		str_msg = GetLanguage("lang_languageupdated")
	
	Case "delete"
	
		' Delete record
		ExecuteRecordset q_DeleteTable("acmstbl_languages","id",int_languageid,"number"), conn, rs
		str_redirect = "acms_languagelist.asp"
		str_msg = GetLanguage("lang_languagedeleted")
				
	Case "disable"
		
		' Update disabled value to True/Yes/1
		q_UpdateBoolean conn,"acmstbl_languages","id",int_languageid,"disabled",True
		str_redirect = "acms_languagelist.asp"
		
	Case "enable"
		
		' Update disabled value to False/No/0
		q_UpdateBoolean conn,"acmstbl_languages","id",int_languageid,"disabled",False
		str_redirect = "acms_languagelist.asp"
	
	Case "reset"
		
		RemoveApplication "lang_*"
		str_msg = GetLanguage("lang_languageresetted")
		str_redirect = "acms_languagelist.asp"
	
	Case Else
	
		str_redirect = "acms_languagelist.asp"
	

End Select
CloseDatabase conn

If NotEmpty(str_msg) Then WriteSession "adminmessage", str_msg
If NotEmpty(str_redirect) Then Response.Redirect str_redirect
%>