<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_languagelist.asp
' Summary  - Lists the languages in the database
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser(c_SUPERONLYACCESS)

' variable declaration
Dim int_languageid, str_languagetitle, bln_disabled
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' functions and subroutines
Sub DoLanguageList()
	
	Dim rs
	ExecuteRecordset q_SelectTable("id,title,disabled","acmstbl_languages","title","","","",""), conn, rs

	If Not rs.EOF Then
		Do Until rs.EOF
			int_languageid = rs("id")
			str_languagetitle = rs("title")
			bln_disabled = CBool(rs("disabled"))
			
			Response.Write "<tr>" & vbCrLf
			DoDataOutput "acms_languageedit.asp?id=" & int_languageid,Server.HTMLEncode(str_languagetitle),"","maincol smlindent","td",""
			If bln_disabled Then
				DoDataOutput "acms_languageaction.asp?id=" & int_languageid & "&amp;action=enable","<img src=""images/admin/empty.gif"" alt=""" & GetLanguage("lang_enable") & """ title=""" & GetLanguage("lang_enable") & """ />","","icon","td",""
			Else
				DoDataOutput "acms_languageaction.asp?id=" & int_languageid & "&amp;action=disable","<img src=""images/admin/full.gif"" alt=""" & GetLanguage("lang_disable") & """ title=""" & GetLanguage("lang_disable") & """ />","","icon","td",""
			End If

			DoDataOutput "javascript:confirmdelete('acms_languageaction.asp?id=" & int_languageid & "&amp;action=delete','" & str_languagetitle & "')","<img src=""images/admin/cross.gif"" alt=""" & GetLanguage("lang_delete") & """ title=""" & GetLanguage("lang_delete") & """ />","","icon","td",""
			Response.Write "</tr>" & vbCrLf
			rs.MoveNext
		Loop
	End If
	
	CloseRecordset rs
	
End Sub

Sub DoMainAdminContent ()
	OpenDatabase conn
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <%=GetLanguage("lang_languages")%></div>
	<table class="tree">
		<tr>
			<td colspan="4" class="add"><a href="acms_languageedit.asp"><%=GetLanguage("lang_addlanguage")%></a></td>
		</tr>
		<% DoLanguageList %>
	</table>
	<table class="form auto">
		<tr>
			<td>
				<form method="post" action="acms_languageaction.asp">
					<input type="hidden" name="action" value="reset" />
					<input type="submit" name="submit" value="<%=GetLanguage("lang_resetlanguage")%>" class="submitbtn" />
				</form>
			</td>
		</tr>
	</table>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<p>Above shows a list of languages that have been created; click on the language title to edit the language details.</p>
		<p>If the language file has been modified, it needs to be resetted; click on the "<%=GetLanguage("lang_resetlanguage")%>"
		button to reload the language file to the server.</p>
		<table class="tbl_instructions">
			<tr>
				<td><img src="images/admin/empty.gif" alt="Enable" title="Enable" width="15" height="15" /></td>
				<td>Indicates language is currently disabled; click to enable the language</td>
			</tr>
			<tr>
				<td><img src="images/admin/full.gif" alt="Disable" title="Disable" width="15" height="15" /></td>
				<td>Indicates language is currently enabled; click to disable the language</td>
			</tr>
			<tr>
				<td><img src="images/admin/cross.gif" alt="Delete" title="Delete" width="15" height="15" /></td>
				<td>Delete the language from the database; files will remain, but the records will be removed</td>
			</tr>
		</table>
	</div>
<%
End Sub
%>