<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_menuaction.asp
' Summary  - Handles menu actions
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser(c_SUPERONLYACCESS)

' variable declaration
Dim int_menuid, str_menutitle, str_filename, bln_hide, bln_core, int_parentid, str_keyword
Dim int_templatedb, str_templatefile, var_template
Dim str_contentbody, int_mode
Dim str_action, str_redirect, str_msg
Dim conn, rs, rs_max
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<%
' end include files

' get form values
str_action = GetValue("action","")
int_menuid = GetValue("id",0) 
str_menutitle = GetValue("title","") 
str_filename = GetValue("filename","")
bln_hide = GetValue("hide",False)
bln_core = GetValue("core",False)
int_parentid = GetValue("parent",0)
str_keyword = GetValue("keyword","")
' end get form values

OpenDatabase conn
Select Case lcase(str_action)

	Case "add"
	
		' Check required fields
		If str_menutitle = "" Then SetError GetLanguage("lang_titlerequired"), "acms_pageedit.asp"
		
		' Check if keyword exists
		If NotEmpty(str_keyword) Then
			ExecuteRecordset q_SelectTable("keyword","acmstbl_menus","","","keyword",str_keyword,"string"), conn, rs
			If Not rs.EOF Then 
				CloseRecordset rs
				SetError GetLanguage("lang_keywordexists"), "acms_pageedit.asp"
			End If
			CloseRecordset rs
		Else
			SetError GetLanguage("lang_keywordrequired"), "acms_pageedit.asp"
		End If
			
		' Insert content
		int_menuid = q_InsertMenu(conn,str_menutitle,str_filename,bln_hide,int_parentid,bln_core,str_keyword)
		str_redirect = "acms_menuedit.asp?id=" & int_menuid
		str_msg = GetLanguage("lang_menuadded")
	
	Case "update"
	
		' Prevent looping
		If int_parentid = int_menuid Then SetError GetLanguage("lang_invalidparent"),"acms_menuedit.asp?id=" & int_menuid
		
		' Check required fields
		If str_menutitle = "" Then SetError GetLanguage("lang_titlerequired"), "acms_pageedit.asp?id=" & int_menuid
		
		' Check if keyword exists
		If NotEmpty(str_keyword) Then
			ExecuteRecordset q_SelectTable("keyword","acmstbl_menus","","id<>" & int_menuid,"keyword",str_keyword,"string"), conn, rs
			If Not rs.EOF Then 
				CloseRecordset rs
				SetError GetLanguage("lang_keywordexists"), "acms_menuedit.asp?id=" & int_menuid
			End If
			CloseRecordset rs
		Else
			SetError GetLanguage("lang_keywordrequired"), "acms_pageedit.asp?id=" & int_menuid
		End If
				
		q_UpdateMenu conn,int_menuid,str_menutitle,str_filename,bln_hide,int_parentid,bln_core,str_keyword
		str_redirect = "acms_menuedit.asp?id=" & int_menuid
		str_msg = GetLanguage("lang_menuupdated")
	
	Case "delete"
	
		' Check if menu item is core
		ExecuteRecordset q_SelectTable("core","acmstbl_menus","","","id",int_menuid,"number"), conn, rs
		If Not rs.EOF Then bln_core = rs("core")
		CloseRecordset rs
		
		' Delete page
		If Not bln_core Then
			ExecuteRecordset q_DeleteTable("acmstbl_menus","id",int_menuid,"number"), conn, rs
		Else
			SetError GetLanguage("lang_cannotdeletecore"),"acms_menulist.asp"
		End If
		
		str_redirect = "acms_menulist.asp"
		str_msg = GetLanguage("lang_menudeleted")
	
	Case "movetoparent"
	
		If int_parentid > 0 Then
					
			' Get parent ID of parent
			ExecuteRecordset q_SelectTable("parentid","acmstbl_menus","","","id",int_parentid,"number"), conn, rs
			If Not rs.EOF Then int_parentid = rs(0)
			CloseRecordset rs
						
			' Set new parent and position to page
			OpenUpdateRecordset q_SelectTable("parentid","acmstbl_menus","","","id",int_menuid,"number"), conn, rs
			If Not rs.EOF Then	
				rs("parentid") = int_parentid
				rs.Update
			End If
			CloseRecordset rs
			
		End If
		
		str_redirect = "acms_menulist.asp"
		
	Case "hide"
		
		' Update hide value to True/Yes/1
		q_UpdateBoolean conn,"acmstbl_menus","id",int_menuid,"hide",True
		str_redirect = "acms_menulist.asp"
		
	Case "unhide"
		
		' Update hide value to False/No/0
		q_UpdateBoolean conn,"acmstbl_menus","id",int_menuid,"hide",False
		str_redirect = "acms_menulist.asp"
	
	Case Else
	
		str_redirect = "acms_pagelist.asp"

End Select
CloseDatabase conn

If NotEmpty(str_msg) Then WriteSession "adminmessage", str_msg
If NotEmpty(str_redirect) Then Response.Redirect str_redirect
%>