<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_menulist.asp
' Summary  - Displays a list of menus in the database
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser(c_SUPERONLYACCESS)

' variable declaration
Dim int_menuid, str_menutitle, str_keyword, str_filename, int_parentid, bln_hide, bln_core
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' functions and subroutines
' Recursive subroutine to generate the page list tree
Sub DoMenuTree(parentid, level)
	
	Dim rs, rs_child
	Dim str_languagetitle, str_tempmenutitle
	
	ExecuteRecordset q_SelectTable("*","acmstbl_menus","core DESC,title","","parentid",parentid,"number"), conn, rs

	If Not rs.EOF Then
		Do Until rs.EOF
			' Put data into variables
			int_menuid = rs("id")
			str_menutitle = rs("title")
			str_keyword = rs("keyword")
			str_filename = rs("filename")
			int_parentid = rs("parentid")
			bln_hide = CBool(rs("hide"))
			bln_core = CBool(rs("core"))
			
			Response.Write "<tr>" & vbCrLf
			DoDataOutput "acms_menuedit.asp?parentid=" & int_menuid,"<img src=""images/admin/add.gif"" alt=""" & GetLanguage("lang_add") & """ title=""" & GetLanguage("lang_add") & """ />","","icon","td",""

			' If menu is Top Level, will not display "move to parent" button
			If parentid > 0 AND Not bln_core Then
				DoDataOutput "acms_menuaction.asp?id=" & int_menuid & "&amp;parent=" & int_parentid & "&amp;action=movetoparent","<img src=""images/admin/toparent.gif"" alt=""" & GetLanguage("lang_movetoparent") & """ title=""" & GetLanguage("lang_movetoparent") & """ />","","icon","td",""
			Else
				DoDataOutput "","&nbsp;","","icon","td",""
			End If

			str_languagetitle = ""
			str_tempmenutitle = ""
			
			str_languagetitle = "lang_menu_" & str_keyword
			str_tempmenutitle = GetLanguage(str_languagetitle)
			If lcase(str_tempmenutitle) <> lcase(str_languagetitle) Then str_menutitle = str_tempmenutitle

			DoDataOutput "acms_menuedit.asp?id=" & int_menuid,Server.HTMLEncode(str_menutitle),"padding-left:" & level*20 & "px","maincol","td",""

			' If hidden, show hidden button
			If bln_hide Then
				DoDataOutput "acms_menuaction.asp?id=" & int_menuid & "&amp;action=unhide","<img src=""images/admin/empty.gif"" alt=""" & GetLanguage("lang_unhide") & """ title=""" & GetLanguage("lang_unhide") & """ />","","icon","td",""
			Else
				DoDataOutput "acms_menuaction.asp?id=" & int_menuid & "&amp;action=hide","<img src=""images/admin/full.gif"" alt=""" & GetLanguage("lang_hide") & """ title=""" & GetLanguage("lang_hide") & """ />","","icon","td",""
			End If

			' Check if menu has children, if children exists, delete button is not shown
			ExecuteRecordset q_SelectTable("id","acmstbl_menus","","","parentid",int_menuid,"number"), conn, rs_child
			If rs_child.EOF AND Not bln_core Then
				DoDataOutput "javascript:confirmdelete('acms_menuaction.asp?id=" & int_menuid & "&amp;parent=" & int_parentid & "&amp;action=delete','" & str_menutitle & "')","<img src=""images/admin/cross.gif"" alt=""" & GetLanguage("lang_delete") & """ title=""" & GetLanguage("lang_delete") & """ />","","icon","td",""
			Else
				DoDataOutput "","&nbsp;","","icon","td",""
			End If
			CloseRecordset rs_child
			
			Response.Write "</tr>" & vbCrLf
			DoMenuTree int_menuid, level + 1 
			rs.MoveNext
		Loop
	End If
	
	CloseRecordset rs
	
End Sub
' end functions and subroutines

' admin template areas
Sub DoMainAdminContent ()
	OpenDatabase conn
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <%=GetLanguage("lang_menus")%></div>
	<table class="tree">
		<tr>
			<td colspan="5" class="add"><a href="acms_menuedit.asp"><%=GetLanguage("lang_addmenu")%></a></td>
		</tr>
		<% DoMenuTree 0,0 %>
	</table>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<p>Above shows a list of menus; click on the menu name to edit the contents of the
		corresponding menu item. See below for explanations of the buttons shown in the menu list.</p>
		<table class="tbl_instructions">
			<tr>
				<td><img src="images/admin/add.gif" alt="Add" title="Add" width="15" height="15" /></td>
				<td>Add a sub-menu item</td>
			</tr>
			<tr>
				<td><img src="images/admin/toparent.gif" alt="Move to parent" title="Move to parent" width="15" height="15" /></td>
				<td>Move the menu item up a level</td>
			</tr>
			<tr>
				<td><img src="images/admin/empty.gif" alt="Unhide" title="Unhide" width="15" height="15" /></td>
				<td>Indicates menu item is currently hidden; click to unhide the menu item</td>
			</tr>
			<tr>
				<td><img src="images/admin/full.gif" alt="Hide" title="Hide" width="15" height="15" /></td>
				<td>Indicates menu item is currently accessible; click to hide the menu item</td>
			</tr>
			<tr>
				<td><img src="images/admin/cross.gif" alt="Delete" title="Delete" width="15" height="15" /></td>
				<td>Delete menu item; for precaution, deletion of parent and/or core menu items are not allowed</td>
			</tr>
		</table>
	</div>
<%
End Sub
' end admin template areas
%>