<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_moduleaction.asp
' Summary  - Handle modules actions
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser(c_SUPERONLYACCESS)

' variable declaration
Dim int_moduleid, str_moduletitle, str_filename, str_calledfilename, str_version, str_keyword
Dim bln_disabled
Dim str_action, str_redirect, str_msg
Dim conn, rs
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<%

' get form values
str_action = GetValue("action","")
int_moduleid = GetValue("id",0) 
str_moduletitle = GetValue("title","") 
str_filename = GetValue("filename","")
str_calledfilename = GetValue("calledfilename","")
str_version = GetValue("version","")
str_keyword = GetValue("keyword","")
bln_disabled = GetValue("disabled",False)

OpenDatabase conn
Select Case lcase(str_action)

	Case "add"
	
		' Check required field
		If str_moduletitle = "" Then SetError GetLanguage("lang_titlerequired"), "acms_moduleedit.asp"
		
		' Check if existing keyword exists
		If NotEmpty(str_keyword) Then
			ExecuteRecordset q_SelectTable("keyword","acmstbl_modules","","","keyword",str_keyword,"string"), conn, rs
			If Not rs.EOF Then 
				CloseRecordset rs
				SetError GetLanguage("lang_keywordexists"), "acms_moduleedit.asp"
			End If
			CloseRecordset rs
		Else
			SetError GetLanguage("lang_keywordrequired"), "acms_moduleedit.asp"
		End If
		
		' Add data
		int_moduleid = q_InsertModule(conn,str_moduletitle,str_filename,str_calledfilename,str_version,str_keyword,bln_disabled)
		
		str_redirect = "acms_moduleedit.asp?id=" & int_moduleid
		str_msg = GetLanguage("lang_moduleadded")
			
	Case "update"
		
		' Check required field
		If str_moduletitle = "" Then SetError GetLanguage("lang_titlerequired"), "acms_moduleedit.asp?id=" & int_moduleid
		
		' Check if existing keyword exists
		If NotEmpty(str_keyword) Then
			ExecuteRecordset q_SelectTable("keyword","acmstbl_modules","","id<>" & int_moduleid,"keyword",str_keyword,"string"), conn, rs
			If Not rs.EOF Then 
				CloseRecordset rs
				SetError GetLanguage("lang_keywordexists"), "acms_moduleedit.asp?id=" & int_moduleid
			End If
			CloseRecordset rs
		Else
			SetError GetLanguage("lang_keywordrequired"), "acms_moduleedit.asp?id=" & int_moduleid
		End If
		
		' Update data
		q_UpdateModule conn,int_moduleid,str_moduletitle,str_filename,str_calledfilename,str_version,str_keyword,bln_disabled
				
		str_redirect = "acms_moduleedit.asp?id=" & int_moduleid
		str_msg = GetLanguage("lang_moduleupdated")
	
	Case "delete"
	
		' Delete record
		ExecuteRecordset q_DeleteTable("acmstbl_modules","id",int_moduleid,"number"), conn, rs
		str_redirect = "acms_modulelist.asp"
		str_msg = GetLanguage("lang_moduledeleted")
				
	Case "disable"
		
		' Update disabled value to True/Yes/1
		q_UpdateBoolean conn,"acmstbl_modules","id",int_moduleid,"disabled",True
		str_redirect = "acms_modulelist.asp"
		
	Case "enable"
		
		' Update disabled value to False/No/0
		q_UpdateBoolean conn,"acmstbl_modules","id",int_moduleid,"disabled",False
		str_redirect = "acms_modulelist.asp"
	
	Case Else
		str_redirect = "acms_modulelist.asp"

End Select
CloseDatabase conn

If NotEmpty(str_msg) Then WriteSession "adminmessage", str_msg
If NotEmpty(str_redirect) Then Response.Redirect str_redirect
%>