<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_moduleedit.asp
' Summary  - Edit module details
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser(c_SUPERONLYACCESS)

' variable declaration
Dim int_moduleid, str_moduletitle, str_filename, str_calledfilename, str_version, str_keyword
Dim bln_disabled, str_disabledchecked
Dim str_action, str_submittext, str_breadcrumb
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' content specific functions and subroutines
Sub GetModuleInformation ()
	
	Dim rs
	int_moduleid = GetValue("id",0)
		
	If int_moduleid = 0 Then
		str_action = "add"
		str_submittext = GetLanguage("lang_add")
		str_breadcrumb = GetLanguage("lang_addmodule")
	Else
		str_action = "update"
		str_submittext = GetLanguage("lang_update")
		OpenRecordset q_SelectTable("*","acmstbl_modules","","","id",int_moduleid,"number"), conn, rs
		If Not rs.EOF Then
			str_moduletitle = rs("title")
			str_breadcrumb = Server.HTMLEncode(str_moduletitle)
			str_filename = rs("filename")
			str_calledfilename = rs("calledfilename")
			str_version = rs("version")
			str_keyword = rs("keyword")
			bln_disabled = CBool(rs("disabled"))
			If bln_disabled Then str_disabledchecked = " checked=""checked"""
		End If
		CloseRecordset rs
	End If
	
End Sub

' Content
Sub DoMainAdminContent ()
	OpenDatabase conn
	GetModuleInformation
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <a href="acms_modulelist.asp"><%=GetLanguage("lang_modules")%>...</a>&nbsp; <%=str_breadcrumb%></div>
	<form method="post" action="acms_moduleaction.asp" name="frm_module" onsubmit="return validate_module(this)">
		<input type="hidden" name="id" value="<%=int_moduleid%>" />
		<input type="hidden" name="action" value="<%=str_action%>" />
		<table class="form">
			<tr>
				<th><%=GetLanguage("lang_title")%></th>
				<td><input type="text" name="title" value="<%=str_moduletitle%>" class="textbox" onblur="onblurvalidate(this);" /> *</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_keyword")%></th>
				<td><input type="text" name="keyword" value="<%=str_keyword%>" class="textbox" onblur="xmlvalidate('acmstbl_modules','id',form.id.value,'keyword',this);" /> *</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_version")%></th>
				<td><input type="text" name="version" value="<%=str_version%>" class="textbox" /></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_filename")%></th>
				<td><input type="text" name="filename" value="<%=str_filename%>" class="textbox" /></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_calledfilename")%></th>
				<td><input type="text" name="calledfilename" value="<%=str_calledfilename%>" class="textbox" /></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_disabled")%></th>
				<td><input type="checkbox" name="disabled"<%=str_disabledchecked%> value="True" /></td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td>
					<input type="submit" name="submit" value="<%=str_submittext%>" class="submitbtn" />
				</td>
			</tr>
		</table>
	</form>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<h3>Snippet Details</h3>
		<table class="tbl_instructions">
			<tr>
				<th><%=GetLanguage("lang_title")%></th>
				<td>The name of the module, and only used as an identifier in the admin; will be used if a 
				translation is not provided. <strong>Required</strong></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_keyword")%></th>
				<td>A simplified and unique name for the module utilising only alphanumerical characters 
				(no spaces); this is used as a key to use for identification in page content. <strong>Required</strong></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_version")%></th>
				<td>Will be used to notify you on new versions of the module.</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_filename")%></th>
				<td>Filename of the administration page.</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_calledfilename")%></th>
				<td>Filename to call to generate content.</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_disabled")%></th>
				<td>Module will no longer be accessible via the menu and content generated by the module will
				not be shown.</td>
			</tr>
		</table>
	</div>
<%
End Sub
%>