<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_pageaction.asp
' Summary  - Handles pages actions
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("pages")

' variable declaration
Dim int_pageid, str_pagetitle, str_filename, str_url, bln_hide, int_parentid, int_ordinal, bln_modified, str_keyword, str_headtags
Dim int_templatedb, str_templatefile, var_template
Dim str_contentbody, int_mode
Dim str_action, str_redirect, str_msg
Dim conn, rs, rs_max
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_pages.asp"-->
<!--#include file="includes/acmsi_snippets.asp"-->
<!--#include file="includes/acmsi_tags.asp"-->
<%
' end include files

' get form values
str_action = GetValue("action","")
int_pageid = GetValue("id",0) 
str_pagetitle = GetValue("title","") 
str_filename = GetValue("filename","")
str_url = GetValue("url","")
bln_hide = GetValue("hide",False)
var_template = GetValue("template",0)
int_templatedb = 0
str_templatefile = ""
If IsNumeric(var_template) Then
	int_templatedb = CLng(var_template)
	str_templatefile = ""
Else
	int_templatedb = 0
	str_templatefile = Trim(var_template)
End If 
int_parentid = GetValue("parent",0)
int_ordinal = GetValue("ordinal",0)
str_keyword = GetValue("keyword","")
str_headtags = GetValue("headtags","")
' end get form values

OpenDatabase conn
Select Case lcase(str_action)

	Case "add"

		' Check required fields
		If str_pagetitle = "" Then
			SetError GetLanguage("lang_titlerequired"), GetReferPage
		ElseIf str_keyword = "" Then
			SetError GetLanguage("lang_keywordrequired"), GetReferPage
		ElseIf str_filename = "" AND str_url = "" Then 
			If str_templatefile = "" AND int_templatedb = 0 Then SetError GetLanguage("lang_templaterequired"), GetReferPage
		End If
		
		' Check if keyword exists
		ExecuteRecordset q_SelectTable("keyword","acmstbl_pages","","","keyword",str_keyword,"string"), conn, rs
		If Not rs.EOF Then 
			CloseRecordset rs
			SetError GetLanguage("lang_keywordexists"), GetReferPage
		End If
		CloseRecordset rs
		
		' Check if filename exists
		If NotEmpty(str_filename) Then
			ExecuteRecordset q_SelectTable("filename","acmstbl_pages","","","filename",str_filename,"string"), conn, rs
			If Not rs.EOF Then 
				CloseRecordset rs
				SetError GetLanguage("lang_filenameexists"), GetReferPage
			End If
			CloseRecordset rs
		End If
			
		' Check position
		ExecuteRecordset q_SelectMaxRecord("ordinal","acmstbl_pages","parentid",int_parentid,"number"), conn, rs_max
		If Not rs_max.EOF Then int_ordinal = rs_max(0) + 1
		CloseRecordset rs_max
		If Not NotEmpty(int_ordinal) Then int_ordinal = 1

		' Insert content
		int_pageid = q_InsertPage(conn,str_pagetitle,str_keyword,str_filename,str_url,int_ordinal,bln_hide,int_templatedb,str_templatefile,int_parentid,False,str_headtags)
				
		str_redirect = "acms_pageedit.asp?id=" & int_pageid
		str_msg = GetLanguage("lang_pageadded")
	
	Case "update"
	
		' Prevent looping
		If int_parentid = int_pageid Then SetError GetLanguage("lang_invalidparent"),"acms_pageedit.asp?id=" & int_pageid
		
		' Check required fields
		If str_pagetitle = "" Then
			SetError GetLanguage("lang_titlerequired"), GetReferPage
		ElseIf str_keyword = "" Then
			SetError GetLanguage("lang_keywordrequired"), GetReferPage
		ElseIf str_filename = "" AND str_url = "" Then 
			If str_templatefile = "" AND int_templatedb = 0 Then SetError GetLanguage("lang_templaterequired"), GetReferPage
		End If
		
		' Check if keyword exists
		ExecuteRecordset q_SelectTable("keyword","acmstbl_pages","","id<>" & int_pageid,"keyword",str_keyword,"string"), conn, rs
		If Not rs.EOF Then 
			CloseRecordset rs
			SetError GetLanguage("lang_keywordexists"), GetReferPage
		End If
		CloseRecordset rs
		
		' Check if filename exists
		If NotEmpty(str_filename) Then
			ExecuteRecordset q_SelectTable("filename","acmstbl_pages","","id<>" & int_pageid,"filename",str_filename,"string"), conn, rs
			If Not rs.EOF Then 
				CloseRecordset rs
				SetError GetLanguage("lang_filenameexists"), GetReferPage
			End If
			CloseRecordset rs
		End If
		
		' Update page data
		OpenUpdateRecordset q_SelectTable("","acmstbl_pages","","","id",int_pageid,"number"), conn, rs
		rs("title") = str_pagetitle
		' If filename has changed, means that generate page is required
		If str_filename <> rs("filename") Then
			If NotEmpty(str_filename) Then rs("modified") = GetBoolean(True)
		End If
		rs("filename") = str_filename
		rs("url") = str_url
		rs("hide") = bln_hide
		rs("template_db") = int_templatedb
		rs("template_file") = str_templatefile
		' If parent has moved, ordinal needs to be adjusted accordingly
		If CLng(rs("parentid")) <> CLng(int_parentid) Then
			' Move pages below up one
			OpenUpdateRecordset q_SelectTable("ordinal","acmstbl_pages","","ordinal > " & rs("ordinal"),"parentid",rs("parentid"),"number"), conn, rs_max
			Do Until rs_max.EOF
				rs_max("ordinal") = rs_max("ordinal") - 1
				rs_max.Update
				rs_max.MoveNext
			Loop
			CloseRecordset rs_max
			
			' Set position of page to last of new parent
			ExecuteRecordset q_SelectMaxRecord("ordinal","acmstbl_pages","parentid",int_parentid,"number"), conn, rs_max
			If Not rs_max.EOF Then int_ordinal = rs_max(0) + 1
			CloseRecordset rs_max
			If Not NotEmpty(int_ordinal) Then int_ordinal = 1
			rs("ordinal") = int_ordinal
		End If
		rs("parentid") = int_parentid
		rs("keyword") = str_keyword
		' Set page to modified if head tags have been changed
		If str_headtags <> rs("headtags") Then rs("modified") = GetBoolean(True)
		rs("headtags") = str_headtags
		rs.Update
		str_redirect = "acms_pageedit.asp?id=" & int_pageid
		str_msg = GetLanguage("lang_pageupdated")
		CloseRecordset rs
	
	Case "delete"
	
		' Move following pages up
		OpenUpdateRecordset q_SelectTable("ordinal,title","acmstbl_pages","ordinal","(ordinal > " & int_ordinal & ")","parentid",int_parentid,"number"), conn, rs
		Do Until rs.EOF
			rs("ordinal") = rs("ordinal") - 1
			rs.Update		
			rs.MoveNext
		Loop
		CloseRecordset rs

		' Delete content
		ExecuteRecordset q_DeleteTable("acmstbl_content","pageid",int_pageid,"number"), conn, rs
		
		' Delete page
		ExecuteRecordset q_DeleteTable("acmstbl_pages","id",int_pageid,"number"), conn, rs
		
		str_redirect = "acms_pagelist.asp"
		str_msg = GetLanguage("lang_pagedeleted")
	
	Case "moveup"
	
		' Swap position with page above
		If int_ordinal > 1 Then	q_UpdatePageOrdinal conn,int_pageid,int_ordinal,int_parentid,"up"
		str_redirect = "acms_pagelist.asp"
	
	Case "movedn"

		' Check if page is at bottom
		ExecuteRecordset q_SelectMaxRecord("ordinal","acmstbl_pages","parentid",int_parentid,"number"), conn, rs_max
		If Not rs_max.EOF Then
			If CLng(int_ordinal) < CLng(rs_max(0)) Then	q_UpdatePageOrdinal conn,int_pageid,int_ordinal,int_parentid,"down"
		End If
		CloseRecordset rs_max
		
		str_redirect = "acms_pagelist.asp"
	
	Case "movetoparent"
	
		If int_parentid > 0 Then
			
			' Move pages below up a position
			OpenUpdateRecordset q_SelectTable("ordinal","acmstbl_pages","ordinal","(ordinal > " & int_ordinal & ")","parentid",int_parentid,"number"), conn, rs
			Do Until rs.EOF
				rs("ordinal") = rs("ordinal") - 1
				rs.Update		
				rs.MoveNext
			Loop
			CloseRecordset rs
		
			' Get parent ID of parent
			ExecuteRecordset q_SelectTable("parentid","acmstbl_pages","","","id",int_parentid,"number"), conn, rs
			If Not rs.EOF Then int_parentid = rs(0)
			CloseRecordset rs
			
			' Get position of last page in new parent
			ExecuteRecordset q_SelectMaxRecord("ordinal","acmstbl_pages","parentid",int_parentid,"number"), conn, rs_max
			If Not rs_max.EOF Then int_ordinal = rs_max(0)
			CloseRecordset rs_max
			
			' Set new parent and position to page
			OpenUpdateRecordset q_SelectTable("ordinal,parentid","acmstbl_pages","","","id",int_pageid,"number"), conn, rs
			If Not rs.EOF Then	
				rs("ordinal") = int_ordinal + 1
				rs("parentid") = int_parentid
				rs.Update
			End If
			CloseRecordset rs
			
		End If
		
		str_redirect = "acms_pagelist.asp"
		
	Case "hide"
		
		' Update hide value to True/Yes/1
		q_UpdateBoolean conn,"acmstbl_pages","id",int_pageid,"hide",True
		str_redirect = "acms_pagelist.asp"
		
	Case "unhide"
		
		' Update hide value to False/No/0
		q_UpdateBoolean conn,"acmstbl_pages","id",int_pageid,"hide",False
		str_redirect = "acms_pagelist.asp"
	
	Case "generate","preview"
		
		int_mode = 0	' preview
		If lcase(str_action) = "generate" then int_mode = 1
		str_contentbody = GeneratePage(int_pageid,int_mode)
		
		' Create page if generate or write content if previewing
		If lcase(str_action) = "generate" Then
			str_redirect = "acms_pageedit.asp?id=" & int_pageid
			str_msg = GetLanguage("lang_pagegenerated")
		Else
			Response.Write str_contentbody
		End If
	
	Case "generateall"
	
		' Get details of all pages and generate them
		OpenUpdateRecordset q_SelectTable("id,modified","acmstbl_pages","","","hide",GetBoolean(False),"boolean"), conn, rs
		Do Until rs.EOF
			int_pageid = rs("id")
			str_contentbody = GeneratePage(int_pageid,1)
			rs.MoveNext
		Loop
		
		str_msg = GetLanguage("lang_allpagesgenerated")
		str_redirect = "acms_pagelist.asp"
		CloseRecordset rs
		
	Case "generateallmod"
	
		' Get details of all modified pages and generate them
		OpenUpdateRecordset q_SelectTable("id,modified","acmstbl_pages","","modified=" & GetBoolean(True),"hide",GetBoolean(False),"boolean"), conn, rs
		Do Until rs.EOF
			int_pageid = rs("id")
			str_contentbody = GeneratePage(int_pageid,1)
			rs.MoveNext
		Loop
		
		str_msg = GetLanguage("lang_allmodifiedpagesgenerated")
		str_redirect = "acms_pagelist.asp"
		CloseRecordset rs
	
	Case "view"
	
		' View page or URL
		ExecuteRecordset q_SelectTable("filename,url","acmstbl_pages","","","id",int_pageid,"number"), conn, rs
		If NotEmpty(rs("filename")) Then
			str_redirect = rs("filename")
		ElseIf NotEmpty(rs("url")) Then
			str_redirect = rs("url")
		Else
			str_redirect = "default.asp?id=" & int_pageid
		End If
		CloseRecordset rs
	
	Case Else
	
		str_redirect = "acms_pagelist.asp"

End Select
CloseDatabase conn

If NotEmpty(str_msg) Then WriteSession "adminmessage", str_msg
If NotEmpty(str_redirect) Then Response.Redirect str_redirect
%>