<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_pageedit.asp
' Summary  - Edit page details; displays related content and snippet list
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("pages")

' variable declaration
Dim int_pageid, str_pagetitle, str_filename, str_url, bln_hide,  int_templatedb, str_templatefile, int_parentid, str_keyword, str_headtags, bln_modified
Dim str_hidechecked, str_modifiedclass, str_filenamedisabled, str_urldisabled
Dim int_contentid, str_contenttitle
Dim str_action, str_submittext, str_breadcrumb
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_pages.asp"-->
<!--#include file="includes/acmsi_tags.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' functions and subroutines
Sub DoTemplateList(selectedtemplate_db,selectedtemplate_file,disabled)

	Dim var_selectedtemplate, str_selected
	Dim int_templateid, str_templatetitle
	Dim fs, folder, file_item
	Dim rs
	
	If selectedtemplate_db > 0 Then 
		var_selectedtemplate = selectedtemplate_db
	Else
		var_selectedtemplate = selectedtemplate_file
	End If
	
	ExecuteRecordset q_SelectTable("id,title","acmstbl_snippets","title","istemplate = " & GetBoolean(True),"","",""), conn, rs
	Response.Write "<select name=""template"" size=""1""" & disabled & ">" & vbCrLf
	Response.Write "	<option value=""0""> --- " & GetLanguage("lang_databasetemplates") & " --- </option>" & vbCrLf
	Do Until rs.EOF
		int_templateid = rs("id")
		str_templatetitle = Server.HTMLEncode(rs("title"))
		str_selected = ""
		If int_templateid = var_selectedtemplate Then str_selected = " selected=""selected"""
		Response.Write "	<option value=""" & int_templateid & """" & str_selected & ">" & str_templatetitle & "</option>" & vbCrLf
		rs.MoveNext
	Loop
	CloseRecordset rs
	
	ReadDirectory "templates", fs, folder
	Response.Write "	<option value="" ""> --- " & GetLanguage("lang_filetemplates") & " --- </option>" & vbCrLf
	For Each file_item In folder.Files
		str_selected = ""
		If file_item.Name = var_selectedtemplate Then str_selected = " selected=""selected"""
		Response.Write "	<option value=""" & file_item.Name & """" & str_selected & ">" & file_item.Name & "</option>" & vbCrLf
	Next
	CloseFSO_Folder fs, folder
	
	Response.Write "</select>" & vbCrLf

	If selectedtemplate_db > 0 Then
		Response.Write "&nbsp; <a href=""acms_templateedit.asp?id=" & selectedtemplate_db & "&amp;mode=1"">Edit Template</a>"
	ElseIf NotEmpty(selectedtemplate_file) Then
		Response.Write "&nbsp; <a href=""acms_templateedit.asp?mode=2&amp;filename=" & selectedtemplate_file & """>Edit Template</a>"
	End If	

End Sub

Sub DoPageList(parentid, level, selectedid, pageid)
	
	Dim int_pageid,	str_pagetitle, str_selectedparent
	Dim str_prefix
	Dim rs, i
	
	ExecuteRecordset q_SelectTable("id,title","acmstbl_pages","ordinal","","parentid",parentid,"number"), conn, rs

	If Not rs.EOF Then
		Do Until rs.EOF
			int_pageid = rs("id")
			str_pagetitle = rs("title")

			str_prefix = ""
			For i = 1 To level
				str_prefix = "--" & str_prefix
			Next
			str_selectedparent = ""
			If CLng(int_pageid) = CLng(selectedid) Then str_selectedparent = " selected=""selected"""
			If (CLng(parentid) <> CLng(pageid)) And (CLng(int_pageid) <> CLng(pageid)) Then 
				Response.Write "	<option value=""" & int_pageid & """" & str_selectedparent & ">" & str_prefix & " " & str_pagetitle & "</option>" & vbCrLf
				DoPageList int_pageid, level + 1, selectedid, pageid
			End If
			rs.MoveNext
		Loop
	End If
	
	CloseRecordset rs
	
End Sub

Sub AddSetContentRecords(pageid,templateid,templatefile)
	
	Dim str_body, str_contentname
	Dim obj_match, obj_matches
	Dim rs

	If NotEmpty(templatefile) Then
		str_body = ReadFile("templates/" & templatefile)
	ElseIf templateid > 0 Then
		ExecuteRecordset q_SelectTable("snippet","acmstbl_snippets","","","id",templateid,"number"), conn, rs
		If Not rs.EOF Then str_body = rs("snippet")
		CloseRecordset rs
	End If
	GetRegExpMatches "\{acms:res\(content\)(.*?)\}", str_body, obj_matches

	For Each obj_match in obj_matches
		str_contentname = GetFirstRecord(obj_match, "name")
		OpenUpdateRecordset q_SelectTable("","acmstbl_content","","setcontentname='" & str_contentname & "'","pageid",int_pageid,"number"), conn, rs
		If rs.EOF Then
			rs.AddNew
			rs("title") = str_contentname
			rs("ordinal") = -1
			rs("parentid") = 0
			rs("pageid") = pageid
			rs("setcontentname") = str_contentname
			rs("contentbody") = "&nbsp;"
			rs.Update
		End If
		CloseRecordset rs
	Next
	
End Sub

Sub DoContentTree(parentid, level)
	
	Dim int_contentid, str_contenttitle, int_parentid, int_ordinal, bln_hide, str_setcontentname
	Dim str_setcontentclass
	Dim rs, rs_child
	
	ExecuteRecordset q_SelectTable("*","acmstbl_content","setcontentname,ordinal,id","pageid = " & int_pageid,"parentid",parentid,"number"), conn, rs

	If Not rs.EOF Then
		Do Until rs.EOF
			int_contentid = rs("id")
			str_contenttitle = rs("title")
			int_parentid = rs("parentid")
			int_ordinal = rs("ordinal")
			bln_hide = CBool(rs("hide"))
			str_setcontentname = rs("setcontentname")

			str_setcontentclass = ""
			If NotEmpty(str_setcontentname) Then str_setcontentclass = " highlight"
			
			Response.Write "<tr>" & vbCrLf
			DoDataOutput "acms_contentedit.asp?parentid=" & int_contentid,"<img src=""images/admin/add.gif"" alt=""" & GetLanguage("lang_add") & """ title=""" & GetLanguage("lang_add") & """ />","","icon","td",""
			If level = 0 and NotEmpty(str_setcontentname) Then
				DoDataOutput "","&nbsp;","","icon","td",""
				DoDataOutput "","&nbsp;","","icon","td",""
			Else
				DoDataOutput "acms_contentaction.asp?id=" & int_contentid & "&amp;parent=" & int_parentid & "&amp;ordinal=" & int_ordinal & "&amp;pageid=" & int_pageid & "&amp;action=moveup","<img src=""images/admin/up.gif"" alt=""" & GetLanguage("lang_moveup") & """ title=""" & GetLanguage("lang_moveup") & """ />","","icon","td",""
				DoDataOutput "acms_contentaction.asp?id=" & int_contentid & "&amp;parent=" & int_parentid & "&amp;ordinal=" & int_ordinal & "&amp;pageid=" & int_pageid & "&amp;action=movedn","<img src=""images/admin/down.gif"" alt=""" & GetLanguage("lang_movedown") & """ title=""" & GetLanguage("lang_movedown") & """ />","","icon","td",""
			End If
			If (parentid > 0) and Not(level>0 AND NotEmpty(str_setcontentname)) Then
				DoDataOutput "acms_contentaction.asp?id=" & int_contentid & "&amp;parent=" & int_parentid & "&amp;ordinal=" & int_ordinal & "&amp;pageid=" & int_pageid & "&amp;action=movetoparent","<img src=""images/admin/toparent.gif"" alt=""" & GetLanguage("lang_movetoparent") & """ title=""" & GetLanguage("lang_movetoparent") & """ />","","icon","td",""
			Else
				DoDataOutput "","&nbsp;","","icon","td",""
			End If
			DoDataOutput "acms_contentedit.asp?id=" & int_contentid & "&amp;pageid=" & int_pageid,Server.HTMLEncode(str_contenttitle),"padding-left:" & level*20 & "px;","maincol" & str_setcontentclass,"td",""
			DoDataOutput "acms_contentview.asp?id=" & int_contentid,"<img src=""images/admin/view.gif"" alt=""" & GetLanguage("lang_view") & """ title=""" & GetLanguage("lang_view") & """ />","","icon","td","contentview"
			If bln_hide Then
				DoDataOutput "acms_contentaction.asp?id=" & int_contentid & "&amp;pageid=" & int_pageid & "&amp;action=unhide","<img src=""images/admin/empty.gif"" alt=""" & GetLanguage("lang_unhide") & """ title=""" & GetLanguage("lang_unhide") & """ />","","icon","td",""
			Else
				DoDataOutput "acms_contentaction.asp?id=" & int_contentid & "&amp;pageid=" & int_pageid & "&amp;action=hide","<img src=""images/admin/full.gif"" alt=""" & GetLanguage("lang_hide") & """ title=""" & GetLanguage("lang_hide") & """ />","","icon","td",""
			End If
			
			ExecuteRecordset q_SelectTable("id","acmstbl_content","","","parentid",int_contentid,"number"), conn, rs_child
			If rs_child.EOF Then
				DoDataOutput "javascript:confirmdelete('acms_contentaction.asp?id=" & int_contentid & "&amp;pageid=" & int_pageid & "&amp;ordinal=" & int_ordinal & "&amp;parent=" & int_parentid & "&amp;action=delete','" & str_contenttitle & "')","<img src=""images/admin/cross.gif"" alt=""" & GetLanguage("lang_delete") & """ title=""" & GetLanguage("lang_delete") & """ />","","icon","td",""
			Else
				DoDataOutput "","&nbsp;","","icon","td",""
			End If
			
			Response.Write "</tr>" & vbCrLf
			DoContentTree int_contentid, level + 1 
			rs.MoveNext
		Loop
	End If
	
	CloseRecordset rs
	
End Sub

Sub DoSnippetList(pageid)
	
	Dim rs, rs_content
	Dim int_snippetid, str_snippetkeyword, str_snippettitle, int_firstcontent
	Dim str_contentlinks
	Dim bln_found
	
	bln_found = false
	ExecuteRecordset q_SelectTable("*","acmstbl_snippets","title","","","",""), conn, rs

	If Not rs.EOF Then
		Do Until rs.EOF
			int_snippetid = rs("id")
			str_snippettitle = rs("title")
			str_snippetkeyword = rs("keyword")
			int_firstcontent = 0
			
			ExecuteRecordset q_SelectTable("id,title","acmstbl_content","title","contentbody LIKE '%{acms:snp(" & str_snippetkeyword & ")%'","pageid",int_pageid,"number"), conn, rs_content
		
			Do Until rs_content.EOF
				bln_found = True
				Response.Write "<tr>" & vbCrLf
				If int_firstcontent = 0 Then
					Response.Write "	<td class=""smlindent al""><a href=""acms_snippetedit.asp?id=" & int_snippetid & "&amp;pageid=" & int_pageid & """>" & Server.HTMLEncode(str_snippettitle) & "</a>" & str_contentlinks & "</td>"
					int_firstcontent = 1
				Else
					Response.write "	<td>&nbsp;</td>"
				End If
				Response.Write "	<td class=""al""><a href=""acms_contentedit.asp?id=" & rs_content("id") & "&amp;pageid=" & int_pageid & """>" & Server.HTMLEncode(rs_content("title")) & "</a></td>"
				Response.Write "</tr>"
				rs_content.MoveNext
			Loop
			CloseRecordset rs_content
			rs.MoveNext
		Loop
	End If
	
	If Not bln_found Then
		Response.Write "<tr>" & vbCrLf
		Response.Write "	<td class=""smlindent al"" colspan=""2"">No direct snippets used on this page (nested snippets will not appear on this list)</td>"
		Response.Write "</tr>" & vbCrLf
	End If
	CloseRecordset rs
	
End Sub


Sub GetPageInformation ()
	
	Dim rs
	int_pageid = GetValue("id",-1)
	int_parentid = GetValue("parentid",0)
	
	If int_pageid < 0 Then
		str_action = "add"
		str_submittext = GetLanguage("lang_add")
		str_breadcrumb = GetLanguage("lang_addpage")
	Else
		str_action = "update"
		str_submittext = GetLanguage("lang_update")
		OpenRecordset q_SelectTable("*","acmstbl_pages","","","id",int_pageid,"number"), conn, rs
		If Not rs.EOF Then
			str_pagetitle = Server.HTMLEncode(rs("title"))
			str_breadcrumb = str_pagetitle
			str_filename = rs("filename")
			If NotEmpty(str_filename) Then str_urldisabled = " disabled=""disabled"""
			str_url = rs("url")
			If NotEmpty(str_url) Then str_filenamedisabled = " disabled=""disabled"""
			bln_hide = CBool(rs("hide"))
			If bln_hide Then str_hidechecked = " checked=""checked"""
			int_templatedb = rs("template_db")
			str_templatefile = rs("template_file")
			int_parentid = rs("parentid")
			str_keyword = rs("keyword")
			str_headtags = rs("headtags")
			bln_modified = CBool(rs("modified"))
			If bln_modified Then str_modifiedclass = " modified"
		Else
			CloseRecordset rs
			SetError "Page does not exist","acms_pagelist.asp"
		End If
		CloseRecordset rs
	End If
	
End Sub
' end functions and subroutines

' admin template areas
Sub DoMainAdminContent ()
	OpenDatabase conn
	GetPageInformation
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <a href="acms_pagelist.asp"><%=GetLanguage("lang_menu_pages")%>...</a>&nbsp; <%=str_breadcrumb%></div>
	<form method="post" action="acms_pageaction.asp" name="frm_page" onsubmit="return validate_page(this)">
		<input type="hidden" name="id" value="<%=int_pageid%>" />
		<input type="hidden" name="action" value="<%=str_action%>" />
		<table class="form">
			<tr>
				<th><%=GetLanguage("lang_title")%></th>
				<td><input type="text" name="title" value="<%=str_pagetitle%>" class="textbox" onblur="onblurvalidate(this);" /> *</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_keyword")%></th>
				<td><input type="text" name="keyword" value="<%=str_keyword%>" class="textbox" onblur="xmlvalidate('acmstbl_pages','id',form.id.value,'keyword',this);" /> *</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_filename")%></th>
				<td><input type="text" name="filename" value="<%=str_filename%>" class="textbox"<%=str_filenamedisabled%> onkeyup="changeenable(this.value,form.url)" /></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_url")%></th>
				<td><input type="text" name="url" value="<%=str_url%>" class="textbox"<%=str_urldisabled%> onkeyup="changeenable(this.value,form.filename); changeenable(this.value,form.template); changeenable(this.value,form.headtags)"/></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_template")%></th>
				<td><%DoTemplateList int_templatedb, str_templatefile, str_filenamedisabled %></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_headtags")%></th>
				<td><textarea name="headtags" class="stdtextarea"<%=str_filenamedisabled%>><%=str_headtags%></textarea></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_parent")%></th>
				<td>
					<select name="parent" size="1">
						<option value="0"><%=GetLanguage("lang_toplevel")%></option>
						<%DoPageList 0, 0, int_parentid, int_pageid%>
					</select>
				</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_hide")%></th>
				<td><input type="checkbox" name="hide"<%=str_hidechecked%> value="True" /></td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td>
					<input type="submit" name="submit" value="<%=str_submittext%>" class="submitbtn" />
				</td>
			</tr>
		</table>
	</form>
	<% If int_pageid > 0 AND str_url = "" Then %>
	<h2><%=GetLanguage("lang_content")%></h2>
	<table class="tree">
		<tr><td colspan="9" class="add"><a href="acms_contentedit.asp?pageid=<%=int_pageid%>">Add Content</a></td></tr>
		<% AddSetContentRecords int_pageid, int_templatedb, str_templatefile %>
		<% DoContentTree 0,0 %>
	</table>
	<iframe name="contentview" src="acms_contentview.asp" class="content" frameborder="">
	
	</iframe>
	<table class="form auto">
		<tr>
			<td>
				<form method="post" action="acms_pageaction.asp" target="_blank">
					<input type="hidden" name="id" value="<%=int_pageid%>" />
					<input type="hidden" name="action" value="preview" />
					<input type="submit" name="submit" value="<%=GetLanguage("lang_previewpage")%>" class="submitbtn" />
				</form>
			</td>
			<td>
				<form method="post" action="acms_pageaction.asp">
					<input type="hidden" name="id" value="<%=int_pageid%>" />
					<input type="hidden" name="action" value="generate" />
					<input type="submit" name="submit" value="<%=GetLanguage("lang_generatepage")%>" class="submitbtn<%=str_modifiedclass%>" />
				</form>
			</td>
			<td>
				<form method="post" action="acms_pageaction.asp" target="_blank">
					<input type="hidden" name="id" value="<%=int_pageid%>" />
					<input type="hidden" name="action" value="view" />
					<input type="submit" name="submit" value="<%=GetLanguage("lang_viewpage")%>" class="submitbtn" />
				</form>
			</td>
		</tr>
	</table>

	<h2><%=GetLanguage("lang_menu_snippets")%></h2>
	<table class="tree">
		<tr>
			<th width="150"><%=GetLanguage("lang_snippet")%></th>
			<th><%=GetLanguage("lang_content")%></th>
		</tr>
		<%
		DoSnippetList int_pageid
		%>
	</table>
	<% End If %>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<h3><%=GetLanguage("lang_page")%></h3>
		<table class="tbl_instructions">
			<tr>
				<th><%=GetLanguage("lang_title")%></th>
				<td>The name of the page, and is used for creating the navigation. <strong>Required</strong></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_keyword")%></th>
				<td>A simplified and unique name for the page utilising only alphanumerical characters (no spaces); 
				this is mainly used as a key to use for snippets and modules. <strong>Required</strong></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_filename")%></th>
				<td>The name of the file to create for the page, including the file extension.  For example, page.html or page.asp.</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_url")%></th>
				<td>When linking to an external website, enter the full URL of the website.</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_template")%></th>
				<td>Select the template to use for the page, this is a <strong>required</strong> field when a filename 
				has been set.</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_headtags")%></th>
				<td>Include page specific stylesheets, JavaScript files, and meta tags; template requires to have {acms:head} between
				the &lt;head&gt; tags.</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_parent")%></th>
				<td>Create the page as a sub-page of an existing page, or set to "Top Level" to set it as a main page.</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_hide")%></th>
				<td>Hide the page from the navigation, but can still be accessed and linked from other pages.</td>
			</tr>
		</table>
		
		<h3><%=GetLanguage("lang_content")%></h3>
		<p>This area shows a list of the content blocks created for the page; click on the content title to edit the 
		content block. See below for explanations of the buttons shown in the content list.</p>
		<p>Set content areas are listed in green, bolded and capitalised; these areas represent content areas in the template 
		that are a part of the design and allow for distinct content in these areas. Parent set content areas cannot be moved 
		or deleted.</p>
		<p>To preview the page before generating the file, click the "Preview Page" button; when the content has been finalised,
		click the "Generate Page" to create the file.  Clicking the "View Page" button will bring up the live version of
		the page.
		<p>When content has been added, modified or deleted, the "Generate Page" button will be highlighted in red
		to alert that the live version of the page is no longer up to date.</p>
		<table class="tbl_instructions">
			<tr>
				<td><img src="images/admin/add.gif" alt="Add" title="Add" width="15" height="15" /></td>
				<td>Add a content block</td>
			</tr>
			<tr>
				<td><img src="images/admin/up.gif" alt="Up" title="Up" width="15" height="15" /></td>
				<td>Move the content up</td>
			</tr>
			<tr>
				<td><img src="images/admin/down.gif" alt="Down" title="Down" width="15" height="15" /></td>
				<td>Move the content down</td>
			</tr>
			<tr>
				<td><img src="images/admin/toparent.gif" alt="Move to parent" title="Move to parent" width="15" height="15" /></td>
				<td>Move the content up a level</td>
			</tr>
			<tr>
				<td><img src="images/admin/view.gif" alt="View" title="View" width="15" height="15" /></td>
				<td>Preview the content</td>
			</tr>
			<tr>
				<td><img src="images/admin/empty.gif" alt="Unhide" title="Unhide" width="15" height="15" /></td>
				<td>Indicates content block is hidden; click to unhide the content</td>
			</tr>
			<tr>
				<td><img src="images/admin/full.gif" alt="Hide" title="Hide" width="15" height="15" /></td>
				<td>Indicates content block is viewable; click to hide the content</td>
			</tr>
			<tr>
				<td><img src="images/admin/cross.gif" alt="Delete" title="Delete" width="15" height="15" /></td>
				<td>Delete content from page; for precaution, deletion of parent content areas is not allowed</td>
			</tr>
		</table>
		<h3><%=GetLanguage("lang_menu_snippets")%></h3>
		<p>This area lists the snippets that are used in the current page, as well as indicating which content block
		is utilising the snippet.  To edit the snippet or content, click on the title of the snippet or content.  Note
		that if the snippet includes other snippet, it will not be listed in this area.</p>
	</div>
<%
End Sub
' end admin template areas
%>