<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_snippetaction.asp
' Summary  - Handles snippets actions
' Version  - 0.7B
' Updated  - 28 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("snippets")

' variable declaration
Dim int_snippetid, str_snippettitle, str_snippet, bln_hide, bln_istemplate, str_keyword, int_pageid
Dim str_action, str_redirect, str_msg
Dim conn, rs, rs_page, rs_content
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_snippets.asp"-->
<%

' get form values
str_action = GetValue("action","")
int_pageid = GetValue("pageid",0) 
int_snippetid = GetValue("id",0) 
str_snippettitle = GetValue("title","") 
str_snippet = GetValue("content","")
str_keyword = GetValue("keyword","")
bln_hide = GetValue("hide",False)
bln_istemplate = GetValue("template",False)

OpenDatabase conn
Select Case lcase(str_action)

	Case "add"
	
		' Check required fields
		If str_snippettitle = "" Then SetError GetLanguage("lang_titlerequired"), "acms_snippetedit.asp"
		
		' Check if existing keyword exists
		If NotEmpty(str_keyword) Then
			ExecuteRecordset q_SelectTable("keyword","acmstbl_snippets","","","keyword",str_keyword,"string"), conn, rs
			If Not rs.EOF Then 
				CloseRecordset rs
				SetError GetLanguage("lang_keywordexists"), "acms_snippetedit.asp"
			End If
			CloseRecordset rs
		Else
			SetError GetLanguage("lang_keywordrequired"), "acms_snippetedit.asp"
		End If

		' Add data
		int_snippetid = q_InsertSnippet(conn,str_snippettitle,str_snippet,str_keyword,False,bln_hide)
		
		str_redirect = "acms_snippetedit.asp?id=" & int_snippetid
		str_msg = GetLanguage("lang_snippetadded")
			
	Case "update"
			
		' Check required fields
		If str_snippettitle = "" Then SetError GetLanguage("lang_titlerequired"), "acms_snippetedit.asp?id=" & int_snippetid
		
		' Check if existing keyword exists
		If NotEmpty(str_keyword) Then
			ExecuteRecordset q_SelectTable("keyword","acmstbl_snippets","","id<>" & int_snippetid,"keyword",str_keyword,"string"), conn, rs
			If Not rs.EOF Then 
				CloseRecordset rs
				SetError GetLanguage("lang_keywordexists"), "acms_snippetedit.asp?id=" & int_snippetid
			End If
			CloseRecordset rs
		Else
			SetError GetLanguage("lang_keywordrequired"), "acms_snippetedit.asp?id=" & int_snippetid
		End If
		
		' Update data
		q_UpdateSnippet conn,int_snippetid,str_snippettitle,str_snippet,str_keyword,False,bln_hide
		
		' Check for content with snippet
		ExecuteRecordset q_SelectTable("DISTINCT(pageid)","acmstbl_content","","contentbody LIKE '%{acms:snp(" & str_keyword & ")%'","","",""), conn, rs
		Do Until rs.EOF
			q_SetModifiedPage conn,rs(0),True 
			rs.MoveNext
		Loop
		CloseRecordset rs
		
		str_redirect = "acms_snippetedit.asp?id=" & int_snippetid
		If int_pageid > 0 Then str_redirect = str_redirect & "&amp;pageid=" & int_pageid
		str_msg = GetLanguage("lang_snippetupdated")

	
	Case "delete"
	
		' Get keyword of snippet
		ExecuteRecordset q_SelectTable("keyword","acmstbl_snippets","","","id",int_snippetid,"number"), conn, rs
		If Not rs.EOF Then str_keyword = rs("keyword")
		CloseRecordset rs
		
		' Check for content with keyword
		ExecuteRecordset q_SelectTable("DISTINCT(pageid)","acmstbl_content","","contentbody LIKE '%{acms:snp(" & str_keyword & ")%'","","",""), conn, rs
		Do Until rs.EOF
			q_SetModifiedPage conn,rs(0),True 
			rs.MoveNext
		Loop
		CloseRecordset rs

		' Delete record
		ExecuteRecordset q_DeleteTable("acmstbl_snippets","id",int_snippetid,"number"), conn, rs
		str_redirect = "acms_snippetlist.asp"
		str_msg = GetLanguage("lang_snippetdeleted")
				
	Case "hide"
		
		' Update hide value to True/Yes/1
		OpenUpdateRecordset q_SelectTable("hide","acmstbl_snippets","","","id",int_snippetid,"number"), conn, rs
		rs("hide") = GetBoolean(True)
		rs.Update
		str_redirect = "acms_snippetlist.asp"
		CloseRecordset rs
		
	Case "unhide"
		
		' Update hide value to False/No/0
		OpenUpdateRecordset q_SelectTable("hide","acmstbl_snippets","","","id",int_snippetid,"number"), conn, rs
		rs("hide") = GetBoolean(False)
		rs.Update
		str_redirect = "acms_snippetlist.asp"
		CloseRecordset rs
	
	Case Else

End Select
CloseDatabase conn

If NotEmpty(str_msg) Then WriteSession "adminmessage", str_msg
If NotEmpty(str_redirect) Then Response.Redirect str_redirect
%>