<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_snippetlist.asp
' Summary  - Lists the snippets in the database
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("snippets")

' variable declaration
Dim int_snippetid, str_snippettitle, bln_hide
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_snippets.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' functions and subroutines
Sub DoSnippetList()
	
	Dim rs
	ExecuteRecordset q_SelectTable("id,title,hide","acmstbl_snippets","title","","istemplate",GetBoolean(False),"boolean"), conn, rs

	If Not rs.EOF Then
		Do Until rs.EOF
			int_snippetid = rs("id")
			str_snippettitle = rs("title")
			bln_hide = CBool(rs("hide"))
			
			Response.Write "<tr>" & vbCrLf
			DoDataOutput "acms_snippetedit.asp?id=" & int_snippetid,Server.HTMLEncode(str_snippettitle),"","maincol smlindent","td",""
			DoDataOutput "acms_snippetview.asp?id=" & int_snippetid,"<img src=""images/admin/view.gif"" alt=""" & GetLanguage("lang_view") & """ title=""" & GetLanguage("lang_view") & """ />","","icon","td","snippetview"
			If bln_hide Then
				DoDataOutput "acms_snippetaction.asp?id=" & int_snippetid & "&amp;action=unhide","<img src=""images/admin/empty.gif"" alt=""" & GetLanguage("lang_unhide") & """ title=""" & GetLanguage("lang_unhide") & """ />","","icon","td",""
			Else
				DoDataOutput "acms_snippetaction.asp?id=" & int_snippetid & "&amp;action=hide","<img src=""images/admin/full.gif"" alt=""" & GetLanguage("lang_hide") & """ title=""" & GetLanguage("lang_hide") & """ />","","icon","td",""
			End If
			DoDataOutput "javascript:confirmdelete('acms_snippetaction.asp?id=" & int_snippetid & "&amp;action=delete','" & str_snippettitle & "')","<img src=""images/admin/cross.gif"" alt=""" & GetLanguage("lang_delete") & """ title=""" & GetLanguage("lang_delete") & """ />","","icon","td",""
			Response.Write "</tr>" & vbCrLf
			rs.MoveNext
		Loop
	End If
	
	CloseRecordset rs
	
End Sub

Sub DoMainAdminContent ()
	OpenDatabase conn
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <%=GetLanguage("lang_menu_snippets")%></div>
	<table class="tree">
		<tr>
			<td colspan="4" class="add"><a href="acms_snippetedit.asp"><%=GetLanguage("lang_addsnippet")%></a></td>
		</tr>
		<% DoSnippetList %>
	</table>
	<iframe name="snippetview" src="acms_snippetview.asp" class="content" frameborder="">
	
	</iframe>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<table class="tbl_instructions">
			<tr>
				<td><img src="images/admin/view.gif" alt="View" title="View" width="15" height="15" /></td>
				<td>Preview the snippet</td>
			</tr>
			<tr>
				<td><img src="images/admin/empty.gif" alt="Unhide" title="Unhide" width="15" height="15" /></td>
				<td>Indicates snippet is hidden; click to unhide the content</td>
			</tr>
			<tr>
				<td><img src="images/admin/full.gif" alt="Hide" title="Hide" width="15" height="15" /></td>
				<td>Indicates snippet is visible; click to hide the content</td>
			</tr>
			<tr>
				<td><img src="images/admin/cross.gif" alt="Delete" title="Delete" width="15" height="15" /></td>
				<td>Delete snippet from database</td>
			</tr>
		</table>
	</div>
<%
End Sub
%>