<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_useraction.asp
' Summary  - Handles users actions
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("users")

' variable declaration
Dim str_username, str_currentusername, str_password, int_usergroup, bln_locked, bln_super
Dim str_action, str_redirect, str_msg
Dim conn, rs, rs_super
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_users.asp"-->
<%

' get form values
str_action = GetValue("action","")
str_username = GetValue("username","")
str_currentusername = GetValue("currentusername","")
str_password = GetValue("password","") 
int_usergroup = GetValue("usergroup",0) 
bln_locked = GetValue("locked",False)
bln_super = GetValue("super",False)

OpenDatabase conn

' Check if username is entered
If str_username = "" Then SetError GetLanguage("lang_usernamerequired"), GetReferPage

Select Case lcase(str_action)

	Case "add"

		' Check if username exists
		If NotEmpty(str_username) Then
			ExecuteRecordset q_SelectTable("username","acmstbl_users","","","username",str_username,"string"), conn, rs
			If Not rs.EOF Then
				CloseRecordset rs
				SetError GetLanguage("lang_usernameexists"), "acms_useredit.asp"
			End If
			CloseRecordset rs
		Else
			SetError GetLanguage("lang_usernamerequired"), "acms_useredit.asp"
		End If
		
		If str_password = "" Then SetError GetLanguage("lang_passwordrequired"), GetReferPage
		
		' Add data
		If GetCookie("super") Then
			If bln_super Then
				q_InsertUser conn,str_username,str_password,True,0,bln_locked
			Else
				q_InsertUser conn,str_username,str_password,False,int_usergroup,bln_locked
			End If
		Else
			q_InsertUser conn,str_username,str_password,False,GetCookie("usergroup"),bln_locked
		End If		
		
		str_redirect = "acms_useredit.asp?username=" & str_username
		str_msg = GetLanguage("lang_useradded")
			
	Case "update"
		
		If str_password = "" Then SetError GetLanguage("lang_passwordrequired"), GetReferPage
		
		If str_username = str_currentusername Then
			OpenUpdateRecordset q_SelectTable("","acmstbl_users","","","username",str_username,"string"), conn, rs
			rs("userpassword") = str_password
			If GetCookie("username") <> str_username Then rs("locked") = GetBoolean(bln_locked)
			If GetCookie("super") AND GetCookie("username") <> str_currentusername Then 
				rs("super") = GetBoolean(bln_super)
				If bln_super Then 
					rs("usergroup") = 0
				Else
					ExecuteRecordset q_SelectTable("super","acmstbl_users","","super=" & GetBoolean(True) & " AND username<>'" & str_username & "'","","",""), conn, rs_super
					If rs_super.EOF Then
						CloseRecordset rs_super
						CloseRecordset rs
						SetError GetLanguage("lang_onesuperuser"), "acms_useredit.asp?username=" & str_username
					End If
					CloseRecordset rs_super
					rs("usergroup") = int_usergroup
				End If
			End If
			rs.Update
			CloseRecordset rs
		Else
			' Check if username exists
			ExecuteRecordset q_SelectTable("username","acmstbl_users","","","username",str_username,"string"), conn, rs
			If Not rs.EOF Then
				CloseRecordset rs
				SetError GetLanguage("lang_usernameexists"), "acms_useredit.asp?username=" & str_currentusername
			End If
			CloseRecordset rs
			
			OpenUpdateRecordset q_SelectTable("","acmstbl_users","","","username",str_currentusername,"string"), conn, rs
			rs("username") = str_username
			rs("userpassword") = str_password
			If GetCookie("username") <> str_username Then rs("locked") = GetBoolean(bln_locked)
			If GetCookie("super") AND GetCookie("username") <> str_currentusername Then 
				rs("super") = GetBoolean(bln_super)
				If bln_super Then 
					rs("usergroup") = 0
				Else
					rs("usergroup") = int_usergroup
				End If
			End If
			rs.Update
			CloseRecordset rs
			
			If GetCookie("username") = str_currentusername Then	WriteCookie "username", str_username
		End If

		str_redirect = "acms_useredit.asp?username=" & str_username
		str_msg = GetLanguage("lang_userupdated")

	
	Case "delete"
		
		' Check if last super user
		ExecuteRecordset q_SelectTable("super","acmstbl_users","","super=" & GetBoolean(True) & " AND username<>'" & str_username & "'","","",""), conn, rs_super
		If rs_super.EOF Then
			CloseRecordset rs_super
			SetError GetLanguage("lang_onesuperuser"), "acms_useredit.asp?username=" & str_username
		End If

		' Delete records from user group access
		ExecuteRecordset q_DeleteTable("acmstbl_users","username",str_username,"string"), conn, rs
		
		str_redirect = "acms_userlist.asp"
		str_msg = GetLanguage("lang_userdeleted")
				
	Case "lock"
		
		' Update hide value to True/Yes/1
		q_UpdateBoolean conn,"acmstbl_users","username",str_username,"locked",True
		str_redirect = "acms_userlist.asp"
		
	Case "unlock"
		
		' Update hide value to False/No/0
		q_UpdateBoolean conn,"acmstbl_users","username",str_username,"locked",False
		str_redirect = "acms_userlist.asp"
		
	Case "setgroup"
	
		q_UpdateUsersUserGroup conn,str_username,int_usergroup
		str_redirect = GetReferPage
	
	Case Else

End Select
CloseDatabase conn

If NotEmpty(str_msg) Then WriteSession "adminmessage", str_msg
If NotEmpty(str_redirect) Then Response.Redirect str_redirect
%>