<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_moduleaction.asp
' Summary  - Handle modules actions
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("mod_nav")

' variable declaration
Dim int_navid, int_levels
Dim str_navtitle, str_keyword, str_navstyle, str_navid
Dim bln_alllevels, bln_static
Dim str_action, str_redirect, str_msg
Dim conn, rs
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<%

' get form values
str_action = GetValue("action","")
int_navid = GetValue("id",0) 
str_navtitle = GetValue("title","") 
str_keyword = GetValue("keyword","") 
str_navstyle = GetValue("style","")
str_navid = GetValue("navid","")
int_levels = GetValue("levels",-1)
bln_alllevels = GetValue("alllevels",False)
bln_static = GetValue("static",False)

OpenDatabase conn
Select Case lcase(str_action)

	Case "add"
	
		' Check required field
		If str_navtitle = "" Then SetError GetLanguage("lang_titlerequired"), "acmsmod_navedit.asp"
		
		' Check if existing keyword exists
		If NotEmpty(str_keyword) Then
			ExecuteRecordset q_SelectTable("keyword","acmsmod_navigation","","","keyword",str_keyword,"string"), conn, rs
			If Not rs.EOF Then 
				CloseRecordset rs
				SetError GetLanguage("lang_keywordexists"), "acmsmod_navedit.asp"
			End If
			CloseRecordset rs
		Else
			SetError GetLanguage("lang_keywordrequired"), "acmsmod_navedit.asp"
		End If
		
		' Add data
		conn.Execute = "INSERT INTO acmsmod_navigation(title,keyword,style,navid,levels,alllevels,static)" &_
				" VALUES ('" & GetDBString(str_navtitle) & "','" & GetDBString(str_keyword) & "','" & GetDBString(str_navstyle) & "','" &_
				GetDBString(str_navid) & "'," & int_levels & "," & GetBoolean(bln_alllevels) & "," & GetBoolean(bln_static) & ");"
		Set rs = conn.Execute("SELECT @@IDENTITY AS id;")
		int_navid = rs("id")
		CloseRecordset rs
				
		str_redirect = "acmsmod_navedit.asp?id=" & int_navid
		str_msg = GetLanguage("lang_mod_navadded")
			
	Case "update"
		
		' Check required field
		If str_navtitle = "" Then SetError GetLanguage("lang_titlerequired"), "acmsmod_navedit.asp?id=" & int_navid
		
		' Check if existing keyword exists
		If NotEmpty(str_keyword) Then
			ExecuteRecordset q_SelectTable("keyword","acmstbl_modules","","id<>" & int_navid,"keyword",str_keyword,"string"), conn, rs
			If Not rs.EOF Then 
				CloseRecordset rs
				SetError GetLanguage("lang_keywordexists"), "acms_moduleedit.asp?id=" & int_navid
			End If
			CloseRecordset rs
		Else
			SetError GetLanguage("lang_keywordrequired"), "acms_moduleedit.asp?id=" & int_navid
		End If
		
		' Update data
		conn.Execute = "UPDATE acmsmod_navigation SET " &_
					"title='" & GetDBString(str_navtitle) & "', " &_
					"keyword='" & GetDBString(str_keyword) & "', " &_
					"style='" & GetDBString(str_navstyle) & "', " &_
					"navid='" & GetDBString(str_navid) & "', " &_
					"levels=" & int_levels & ", " &_
					"alllevels=" & GetBoolean(bln_alllevels) & ", " &_
					"static=" & GetBoolean(bln_static) & " " &_
					"WHERE id=" & int_navid & ";"
				
		str_redirect = "acmsmod_navedit.asp?id=" & int_navid
		str_msg = GetLanguage("lang_mod_navupdated")
	
	Case "delete"
	
		' Delete record
		ExecuteRecordset q_DeleteTable("acmsmod_navigation","id",int_navid,"number"), conn, rs
		str_redirect = "acmsmod_navlist.asp"
		str_msg = GetLanguage("lang_mod_navdeleted")
					
	Case Else
		str_redirect = "acmsmod_navlist.asp"

End Select
CloseDatabase conn

If NotEmpty(str_msg) Then WriteSession "adminmessage", str_msg
If NotEmpty(str_redirect) Then Response.Redirect str_redirect
%>