<%
' *******************************************************************************
' AtomatiCMS
' Filename - acmsmod_navedit.asp
' Summary  - Edit module details
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("mod_nav")

' variable declaration
Dim str_navtitle, str_keyword, str_style, str_navid, str_selected, str_alllevelschecked, str_staticchecked
Dim int_navid, int_levels
Dim bln_alllevels, bln_static
Dim str_action, str_submittext, str_breadcrumb
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' content specific functions and subroutines
Sub GetNavInformation ()
	
	Dim rs
	int_navid = GetValue("id",0)
		
	If int_navid = 0 Then
		str_action = "add"
		str_submittext = GetLanguage("lang_add")
		str_breadcrumb = GetLanguage("lang_mod_addnav")
	Else
		str_action = "update"
		str_submittext = GetLanguage("lang_update")
		OpenRecordset q_SelectTable("*","acmsmod_navigation","","","id",int_navid,"number"), conn, rs
		If Not rs.EOF Then
			str_navtitle = rs("title")
			str_breadcrumb = Server.HTMLEncode(str_navtitle)
			str_style = rs("style")
			str_navid = rs("navid")
			str_keyword = rs("keyword")
			int_levels = rs("levels")
			bln_alllevels = CBool(rs("alllevels"))
			bln_static = CBool(rs("static"))
			If bln_alllevels Then str_alllevelschecked = " checked=""checked"""
			If bln_static Then str_staticchecked = " checked=""checked"""
			If int_levels < 0 Then int_levels = ""
		End If
		CloseRecordset rs
	End If
	str_selected = " selected=""selected"""
	
End Sub

' Content
Sub DoMainAdminContent ()
	OpenDatabase conn
	GetNavInformation
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <a href="acmsmod_navlist.asp"><%=GetLanguage("lang_mod_nav")%>...</a>&nbsp; <%=str_breadcrumb%></div>
	<form method="post" action="acmsmod_navaction.asp" name="frm_nav">
		<input type="hidden" name="id" value="<%=int_navid%>" />
		<input type="hidden" name="action" value="<%=str_action%>" />
		<table class="form">
			<tr>
				<th><%=GetLanguage("lang_title")%></th>
				<td><input type="text" name="title" value="<%=str_navtitle%>" class="textbox" onblur="onblurvalidate(this);" /> *</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_keyword")%></th>
				<td><input type="text" name="keyword" value="<%=str_keyword%>" class="textbox" onblur="xmlvalidate('acmsmod_navigation','id',form.id.value,'keyword',this);" /> *</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_mod_navstyle")%></th>
				<td>
					<select name="style">
						<option value="li"<% If lcase(str_style)="li" Then Response.Write str_selected%>>List</option>
						<option value="td"<% If lcase(str_style)="td" Then Response.Write str_selected%>>Table (Horizontal)</option>
						<option value="tr"<% If lcase(str_style)="tr" Then Response.Write str_selected%>>Table (Vertical)</option>
					</select>
				</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_mod_navid")%></th>
				<td><input type="text" name="navid" value="<%=str_navid%>" class="textbox" /></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_mod_alllevels")%></th>
				<td><input type="checkbox" name="alllevels"<%=str_alllevelschecked%> value="True" onclick="changeenablechecked(this,form.levels); changeenablechecked(this,form.static);" /></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_mod_navlevels")%></th>
				<td><input type="text" name="levels" value="<%=int_levels%>" size="3" onkeyup="changeenable(this.value,form.alllevels);" /></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_mod_navstatic")%></th>
				<td><input type="checkbox" name="static"<%=str_staticchecked%> value="True" onclick="changeenablechecked(this,form.alllevels);" /></td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td>
					<input type="submit" name="submit" value="<%=str_submittext%>" class="submitbtn" />
				</td>
			</tr>
		</table>
	</form>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<table class="tbl_instructions">
			<tr>
				<th><%=GetLanguage("lang_title")%></th>
				<td>The name of the navigation, and only used as an identifier in the admin. <strong>Required</strong></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_keyword")%></th>
				<td>A simplified and unique name for the snippet utilising only alphanumerical characters (no spaces); 
				this is used as a key to use for generating the specified navigation. <strong>Required</strong></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_mod_navstyle")%></th>
				<td>The style to generate the navigation.</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_mod_alllevels")%></th>
				<td>Show all pages in the navigation</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_mod_navlevels")%></th>
				<td>Number of levels of pages to show- specifying 0 will generate only main pages</td>
			</tr>
		</table>
	</div>
<%
End Sub
%>