<%
' *******************************************************************************
' AtomatiCMS
' Filename - acmsf_database.asp
' Summary  - Database related functions and subroutines
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

Sub OpenDatabase(conn)

	Dim str_connection, str_dblocation
	
	Select Case lcase(c_DATABASETYPE)
	
		Case "access","access2007"
			str_dblocation = c_DATABASENAME
			If Instr(c_DATABASELOCATION,":") > 0 Then
				str_dblocation = c_DATABASELOCATION & "\" & c_DATABASENAME
			ElseIf NotEmpty(c_DATABASELOCATION) Then 
				str_dblocation = Server.MapPath(c_DATABASELOCATION & "\" & c_DATABASENAME)
			End If
			
			If lcase(c_DATABASETYPE) = "access" Then
				str_connection = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & str_dblocation & ";"
			Else
				str_connection = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" & str_dblocation & ";"
			End If
			If NotEmpty(c_DATABASEPWD) Then 
				str_connection = str_connection & "Jet OLEDB:Database Password=" & c_DATABASEPWD & ";"
			Else
				str_connection = str_connection & "Persist Security Info=False;"
			End If
				
		Case "mysql"
			str_connection = "Driver={MYSQL ODBC 3.51 Driver};Server=" & c_DATABASELOCATION & ";Database=" & c_DATABASENAME & ";UID=" & c_DATABASEID & ";PWD=" & c_DATABASEPWD & ";OPTION=3;"
			
		Case "sqlserver"
			str_connection = "Driver={SQL Server};Server=" & c_DATABASELOCATION & ";Database=" & c_DATABASENAME & ";UID=" & c_DATABASEID & ";PWD=" & c_DATABASEPWD & ";"
		
		Case Else
	
	End Select
	Set conn = Server.CreateObject("ADODB.Connection")
	conn.ConnectionTimeout = 20
	On Error Resume Next
	conn.Open(str_connection)
	If Err.Number <> 0 then
		SetError Err.Description, GetReferPage
		Error.Clear
	End If

End Sub

Sub CloseDatabase (conn)

	on error resume next
	conn.close
	set conn=nothing
	If Err.Number <> 0 then
		WriteSession "adminerror", Err.Description
		Error.Clear
	End If
	
End sub

Sub OpenRecordset(table,conn,rs)

	Set rs = Server.CreateObject("ADODB.RecordSet")
	rs.Open table,conn,adOpenStatic,adLockOptimistic
	
End Sub

Sub OpenUpdateRecordset(sql,conn,rs)

	Set rs = Server.CreateObject("ADODB.RecordSet")
	rs.CursorLocation = adUseClient
	rs.Open sql,conn,adOpenKeyset,adLockPessimistic,adCmdText
	
End Sub

Sub ExecuteRecordSet (sql,conn,rs)
	
	Set rs = conn.execute(sql)
	
end sub

Sub CloseRecordset(rs)

	rs.Close
	Set rs = Nothing
	
End Sub

Function GetBoolean(invalue)

	Dim outvalue
	Select Case lcase(c_DATABASETYPE)

		Case "access","access2007"
			If invalue Then
				outvalue = True
			Else
				outvalue = False
			End If
			
		Case "mysql", "sqlserver"
			If invalue Then
				outvalue = 1
			Else
				outvalue = 0
			End If
		
		Case Else
	
	End Select
	GetBoolean = outvalue
	
End Function

Function GetDataType(invalue)

	Dim outvalue
	If IsNumeric(invalue) Then
		outvalue = invalue
	Else
		outvalue = "'" & invalue & "'"
	End If
	GetDataType = outvalue

End Function

Function GetFieldValue(invalue,valuetype)

	Dim outvalue
	Select Case lcase(valuetype)
		Case "string"
			outvalue = "'" & GetDBString(invalue) & "'"
			
		Case "number"
			outvalue = invalue
			
		Case "date"
			outvalue = GetDateDelimit(invalue)
			
		Case "boolean"
			outvalue = GetBoolean(invalue)

		Case Else
			outvalue = 	invalue
			
	End Select
	GetFieldValue = outvalue

End Function

Function GetDateDelimit(invalue)

	Dim outvalue
	
	Select Case lcase(c_DATABASETYPE)
	
		Case "access","access2007"
			outvalue = "#" & invalue & "#"
		
		Case Else
			outvalue = "'" & invalue & "'"
	
	End Select
	
	GetDateDelimit = outvalue

End Function

Function GetDBString(invalue)

	Dim outvalue
	outvalue = invalue
	outvalue = Replace(outvalue,"'","''")
	GetDBString = outvalue

End Function
%>