<%
' *******************************************************************************
' AtomatiCMS
' Filename - acmsi_content.asp
' Summary  - Special functions and subroutines relating to tags
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

Sub GetCommaRecords(invalue,stringfind,outarray)

	Dim obj_regexp, obj_matches, obj_match
	Dim outvalue
	
	Set obj_regexp = new RegExp
	obj_regexp.Pattern = stringfind & "\((.*?)\)"
	obj_regexp.IgnoreCase = True
	obj_regexp.Global = True
	Set obj_matches = obj_regexp.Execute(invalue)
	If obj_matches.Count > 0 Then
		outvalue = obj_matches(0).SubMatches(0)
		outarray = Split(outvalue,",")
	Else
		outarray = ""
	End If
	Set obj_regexp = Nothing
	
End Sub

Sub GetInnerCommaRecords(invalue,stringfind,outarray)

	Dim obj_regexp, obj_matches, obj_match
	Dim outvalue
	
	Set obj_regexp = new RegExp
	obj_regexp.Pattern = stringfind & "\='(.*?)'"
	obj_regexp.IgnoreCase = True
	obj_regexp.Global = True
	Set obj_matches = obj_regexp.Execute(invalue)
	If obj_matches.Count > 0 Then
		outvalue = obj_matches(0).SubMatches(0)
		outarray = Split(outvalue,",")
	Else
		outarray = ""
	End If
	Set obj_regexp = Nothing
	
End Sub

Function GetFirstRecord(inobj,stringfind)

	Dim obj_regexp, obj_matches, obj_match
	Dim outvalue
	
	Set obj_regexp = new RegExp
	obj_regexp.Pattern = stringfind & "\((.*?)\)"
	obj_regexp.IgnoreCase = True
	obj_regexp.Global = True
	Set obj_matches = obj_regexp.Execute(inobj)
	If obj_matches.Count > 0 Then
		outvalue = obj_matches(0).SubMatches(0)
	Else
		outvalue = ""
	End If
	Set obj_regexp = Nothing
	GetFirstRecord = outvalue
	
End Function

Function GetInnerFirstRecord(inobj,stringfind)

	Dim obj_regexp, obj_matches, obj_match
	Dim outvalue
	
	Set obj_regexp = new RegExp
	obj_regexp.Pattern = stringfind & "\='(.*?)'"
	obj_regexp.IgnoreCase = True
	obj_regexp.Global = True
	Set obj_matches = obj_regexp.Execute(inobj)
	If obj_matches.Count > 0 Then
		outvalue = obj_matches(0).SubMatches(0)
	Else
		outvalue = ""
	End If
	Set obj_regexp = Nothing
	GetInnerFirstRecord = outvalue
	
End Function

Function GetKey(code,invalue)

	Dim obj_matches
	Dim outvalue
	
	GetRegExpMatches "\{acms:" & code & "\((.*?)\)", invalue, obj_matches
	outvalue = lcase(obj_matches(0).SubMatches(0))
	GetKey = outvalue

End Function

Function GetInnerKey(code,invalue)

	Dim obj_matches
	Dim outvalue
	
	GetRegExpMatches "\[acms:" & code & "\='(.*?)'", invalue, obj_matches
	If obj_matches.Count > 0 Then
		outvalue = lcase(obj_matches(0).SubMatches(0))
	Else
		outvalue = ""
	End If
	GetInnerKey = outvalue

End Function

Function HasACMSExpression(invalue,stringfind)

	Dim obj_regexp, obj_matches
	Dim outvalue
	
	Set obj_regexp = new RegExp
	obj_regexp.Pattern = "\{" & stringfind & "\((.*?)\)\}"
	obj_regexp.IgnoreCase = True
	obj_regexp.Global = True
	Set obj_matches = obj_regexp.Execute(invalue)
	outvalue = obj_matches.Count
	Set obj_regexp = Nothing
	
	HasACMSExpression = outvalue

End Function

Function HasACMSInnerExpression(invalue,stringfind)

	Dim obj_regexp, obj_matches
	Dim outvalue
	
	Set obj_regexp = new RegExp
	obj_regexp.Pattern = "\[" & stringfind & "='(.*?)'\]"
	obj_regexp.IgnoreCase = True
	obj_regexp.Global = True
	Set obj_matches = obj_regexp.Execute(invalue)
	outvalue = obj_matches.Count
	Set obj_regexp = Nothing
	
	HasACMSInnerExpression = outvalue

End Function

%>