// *******************************************************************************
// AtomatiCMS
// Filename - validation.js
// Summary  - Javascript validation
// Version  - 0.7B
// Updated  - 28 January 2007
// (c) 2006 by Joseph Chang (joseph@atomaticsoftware.com)
// http://www.atomaticsoftware.com

// This file is part of AtomatiCMS.

// AtomatiCMS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// AtomatiCMS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with AtomatiCMS; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
// *******************************************************************************

var tempfield;
var currentobject='';
var activate=true;

function validate_content(thisform) {
	
	var errors;
	errors = ""
	
	if(isWhitespace(thisform.title.value)) {
		errors=errors+getLanguage("lang_titlerequired")+"<br />";
	}
		
	if(errors!="") {
		document.getElementById("message").innerHTML="<p>" + errors + "<" + "/p>"
		return false;
	}
	
	document.getElementById("message").innerHTML = "";
	return true;
}

function validate_file(thisform) {
	
	var errors;
	errors = ""
	
	if(isWhitespace(thisform.filename.value)) {
		errors=errors+getLanguage("lang_filenamerequired")+"<br />";
	}
	
	if(isWhitespace(thisform.content.value)) {
		errors=errors+getLanguage("lang_contentrequired")+"<br />";
	}
		
	if(errors!="") {
		document.getElementById("message").innerHTML="<p>" + errors + "<" + "/p>"
		return false;
	}
	
	document.getElementById("message").innerHTML = "";
	return true;
}

function validate_language(thisform) {
	
	var errors;
	errors = ""
	
	if(isWhitespace(thisform.title.value)) {
		errors=errors+getLanguage("lang_titlerequired")+"<br />";
	}
	
	if(isWhitespace(thisform.keyword.value)) {
		errors=errors+getLanguage("lang_keywordrequired")+"<br />";
	} else if(!isAlphanumeric(thisform.keyword.value)) {
		errors=errors+getLanguage("lang_invalidcharacters")+": keyword<br />";
	}
	
	if(errors!="") {
		document.getElementById("message").innerHTML="<p>" + errors + "<" + "/p>"
		return false;
	}
	
	document.getElementById("message").innerHTML = "";
	return true;
}

function validate_login(thisform) {
	
	var errors;
	errors = ""
	
	if(isWhitespace(thisform.username.value)) {
		errors=errors+getLanguage("lang_usernamerequired")+"<br />";
	}
	
	if(isWhitespace(thisform.password.value)) {
		errors=errors+getLanguage("lang_passwordrequired")+"<br />";
	}
				
	if(errors!="") {
		document.getElementById("message").innerHTML="<p>" + errors + "<" + "/p>"
		return false;
	}
	
	document.getElementById("message").innerHTML = "";
	return true;
}

function validate_menu(thisform) {
	
	var errors;
	errors = ""
	
	if(isWhitespace(thisform.title.value)) {
		errors=errors+getLanguage("lang_titlerequired")+"<br />";
	}
	
	if(isWhitespace(thisform.keyword.value)) {
		errors=errors+getLanguage("lang_keywordrequired")+"<br />";
	} else if(!isAlphanumeric(thisform.keyword.value)) {
		errors=errors+getLanguage("lang_invalidcharacters")+": keyword<br />";
	}
	
	if(errors!="") {
		document.getElementById("message").innerHTML="<p>" + errors + "<" + "/p>"
		return false;
	}
	
	document.getElementById("message").innerHTML = "";
	return true;
}

function validate_module(thisform) {
	
	var errors;
	errors = ""
	
	if(isWhitespace(thisform.title.value)) {
		errors=errors+getLanguage("lang_titlerequired")+"<br />";
	}
	
	if(isWhitespace(thisform.keyword.value)) {
		errors=errors+getLanguage("lang_keywordrequired")+"<br />";
	} else if(!isAlphanumeric(thisform.keyword.value)) {
		errors=errors+getLanguage("lang_invalidcharacters")+": keyword<br />";
	}
	
	if(errors!="") {
		document.getElementById("message").innerHTML="<p>" + errors + "<" + "/p>"
		return false;
	}
	
	document.getElementById("message").innerHTML = "";
	return true;
}

function validate_page(thisform) {
	
	var errors;
	errors = ""
	
	if(isWhitespace(thisform.title.value)) {
		errors=errors+getLanguage("lang_titlerequired")+"<br />";
	}
	
	if(isWhitespace(thisform.keyword.value)) {
		errors=errors+getLanguage("lang_keywordrequired")+"<br />";
	} else if(!isAlphanumeric(thisform.keyword.value)) {
		errors=errors+getLanguage("lang_invalidcharacters")+": keyword<br />";
	}
	
	if((!isWhitespace(thisform.filename.value))&&(isWhitespace(thisform.template.value)||thisform.template.value==0)) {
		errors=errors+getLanguage("lang_templaterequired")+"<br />";
	}
	
	if((isWhitespace(thisform.filename.value)&&isWhitespace(thisform.url.value))&&(isWhitespace(thisform.template.value)||thisform.template.value==0)) {
		errors=errors+getLanguage("lang_templaterequired")+"<br />";
	}
	
	if(errors!="") {
		document.getElementById("message").innerHTML="<p>" + errors + "<" + "/p>"
		return false;
	}
	
	document.getElementById("message").innerHTML = "";
	return true;
}

function validate_snippet(thisform) {
	
	var errors;
	errors = ""
	
	if(isWhitespace(thisform.title.value)) {
		errors=errors+getLanguage("lang_titlerequired")+"<br />";
	}
	
	if(isWhitespace(thisform.keyword.value)) {
		errors=errors+getLanguage("lang_keywordrequired")+"<br />";
	} else if(!isAlphanumeric(thisform.keyword.value)) {
		errors=errors+getLanguage("lang_invalidcharacters")+": keyword<br />";
	}
		
	if(errors!="") {
		document.getElementById("message").innerHTML="<p>" + errors + "<" + "/p>"
		return false;
	}
	
	document.getElementById("message").innerHTML = "";
	return true;
}

function validate_template(thisform) {
	
	var errors;
	errors = ""
	
	if(isWhitespace(thisform.title.value)) {
		errors=errors+getLanguage("lang_titlerequired")+"<br />";
	}
		
	if(errors!="") {
		document.getElementById("message").innerHTML="<p>" + errors + "<" + "/p>"
		return false;
	}
	
	document.getElementById("message").innerHTML = "";
	return true;
}

function validate_user(thisform) {
	
	var errors;
	errors = ""
	
	if(isWhitespace(thisform.username.value)) {
		errors=errors+getLanguage("lang_usernamerequired")+"<br />";
	}
	
	if(isWhitespace(thisform.password.value)) {
		errors=errors+getLanguage("lang_passwordrequired")+"<br />";
	}
	
	if(errors!="") {
		document.getElementById("message").innerHTML="<p>" + errors + "<" + "/p>"
		return false;
	}
	
	document.getElementById("message").innerHTML = "";
	return true;
}

function validate_usergroup(thisform) {
	
	var errors;
	errors = ""
	
	if(isWhitespace(thisform.groupname.value)) {
		errors=errors+getLanguage("lang_groupnamerequired")+"<br />";
	}
	
	if(errors!="") {
		document.getElementById("message").innerHTML="<p>" + errors + "<" + "/p>"
		return false;
	}
	
	document.getElementById("message").innerHTML = "";
	return true;
}

function onblurvalidate(field)
{
	if(!activate) {
		activate = true;
		return;
	}
	
	tempfield = field;
	if (currentobject!=''&&currentobject!= field.name) return;
	currentobject=field.name;
	
	if(field.value=="") {
		document.getElementById("message").innerHTML="<p>" + field.name + " is Empty<" + "/p>";
		setTimeout("tempfield.focus();",10);
		return false;
	}
	else {
		document.getElementById("message").innerHTML="";
		currentobject="";
		return true;
	}
}

function xmlvalidate(table,key,keyvalue,fieldname,field)
{ 
	var outvalue="";
	
	tempfield = field;
	if(!onblurvalidate(field)) {
		return;
	}
	
	xmlHttp=GetXmlHttpObject();
	if (xmlHttp==null)
		return;
		
	var url="acms_jsvalidate.asp";
	url=url+"?table="+table;
	url=url+"&key="+key;
	url=url+"&keyvalue="+keyvalue;
	url=url+"&fieldname="+fieldname;
	url=url+"&fieldvalue="+field.value;
	url=url+"&sid="+Math.random();
	xmlHttp.open("GET",url,false);
	xmlHttp.send(null);
	if (xmlHttp.readyState==4 || xmlHttp.readyState=="complete") {
		document.getElementById("message").innerHTML=xmlHttp.responseText
		if(!isWhitespace(document.getElementById("message").innerHTML)) {
			activate = false;	
			setTimeout("tempfield.focus();",10);
		}
	}
}